/* A Bison parser, made by GNU Bison 2.5.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "parser.y"


/* Copyright 2009-2022
 * Kaz Kylheku <kaz@kylheku.com>
 * Vancouver, Canada
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <stddef.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>
#include <stdlib.h>
#include <wchar.h>
#include <signal.h>
#include "config.h"
#include "alloca.h"
#include "lib.h"
#include "signal.h"
#include "unwind.h"
#include "regex.h"
#include "match.h"
#include "hash.h"
#include "struct.h"
#include "eval.h"
#include "tree.h"
#include "y.tab.h"
#include "debug.h"
#include "txr.h"
#include "itypes.h"
#include "buf.h"
#include "parser.h"

static void set_syntax_tree(parser_t *parser, val tree);
static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed);
static val repeat_rep_helper(val sym, val args, val main, val parts);
static void process_catch_exprs(val exprs);
static val define_transform(parser_t *parser, val define_form);
static val optimize_text(val text_form);
static val unquotes_occur(val quoted_form, int level);
static val rlrec(parser_t *, val form, val line);
static val rlcp_parser(parser_t *parser, val to, val from);
static wchar_t char_from_name(const wchar_t *name);
static val make_expr(parser_t *, val sym, val rest, val lineno);
static val check_parse_time_action(val spec_rev);
static val uref_helper(parser_t *, val expr);
static val uoref_helper(parser_t *, val expr);
static val qref_helper(parser_t *, val lexpr, val rexpr);
static val fname_helper(parser_t *, val name);

#if YYBISON
union YYSTYPE;
int yylex(union YYSTYPE *, yyscan_t scanner);
int yyparse(scanner_t *, parser_t *);
#endif

#define rl(form, line) rlrec(parser, form, line)
#define rlc(to, from) rlcp_parser(parser, to, from)
#define mkexp(sym, rest, lineno) make_expr(parser, sym, rest, lineno)
#define symhlpr(lexeme, meta_allowed) sym_helper(parser, lexeme, meta_allowed)
#define yyerr(msg) yyerror(scnr, parser, msg)
#define yybadtok(tok, context) yybadtoken(parser, tok, context)
#define ifnign(expr) (parser->ignore ? nil : (expr))

INLINE val expand_forms_ver(val forms, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand_forms(forms, nil);
  return forms;
}

INLINE val expand_form_ver(val form, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand(form, nil);
  return form;
}



/* Line 268 of yacc.c  */
#line 174 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SPACE = 258,
     TEXT = 259,
     SYMTOK = 260,
     ALL = 261,
     SOME = 262,
     NONE = 263,
     MAYBE = 264,
     CASES = 265,
     BLOCK = 266,
     CHOOSE = 267,
     GATHER = 268,
     AND = 269,
     OR = 270,
     END = 271,
     COLLECT = 272,
     UNTIL = 273,
     COLL = 274,
     OUTPUT = 275,
     REPEAT = 276,
     REP = 277,
     SINGLE = 278,
     FIRST = 279,
     LAST = 280,
     EMPTY = 281,
     MOD = 282,
     MODLAST = 283,
     DEFINE = 284,
     TRY = 285,
     CATCH = 286,
     FINALLY = 287,
     IF = 288,
     ERRTOK = 289,
     HASH_BACKSLASH = 290,
     HASH_SLASH = 291,
     DOTDOT = 292,
     HASH_H = 293,
     HASH_S = 294,
     HASH_R = 295,
     HASH_J = 296,
     HASH_SEMI = 297,
     HASH_B_QUOTE = 298,
     HASH_N = 299,
     HASH_T = 300,
     WORDS = 301,
     WSPLICE = 302,
     QWORDS = 303,
     QWSPLICE = 304,
     SECRET_ESCAPE_R = 305,
     SECRET_ESCAPE_E = 306,
     SECRET_ESCAPE_I = 307,
     SECRET_ESCAPE_J = 308,
     OLD_DOTDOT = 309,
     NUMBER = 310,
     METANUM = 311,
     JSKW = 312,
     HASH_N_EQUALS = 313,
     HASH_N_HASH = 314,
     REGCHAR = 315,
     REGTOKEN = 316,
     LITCHAR = 317,
     SPLICE = 318,
     JSPLICE = 319,
     OLD_AT = 320,
     CONSDOT = 321,
     LAMBDOT = 322,
     UREFDOT = 323,
     OREFDOT = 324,
     UOREFDOT = 325,
     LOW = 326,
     ELSE = 327,
     ELIF = 328
   };
#endif
/* Tokens.  */
#define SPACE 258
#define TEXT 259
#define SYMTOK 260
#define ALL 261
#define SOME 262
#define NONE 263
#define MAYBE 264
#define CASES 265
#define BLOCK 266
#define CHOOSE 267
#define GATHER 268
#define AND 269
#define OR 270
#define END 271
#define COLLECT 272
#define UNTIL 273
#define COLL 274
#define OUTPUT 275
#define REPEAT 276
#define REP 277
#define SINGLE 278
#define FIRST 279
#define LAST 280
#define EMPTY 281
#define MOD 282
#define MODLAST 283
#define DEFINE 284
#define TRY 285
#define CATCH 286
#define FINALLY 287
#define IF 288
#define ERRTOK 289
#define HASH_BACKSLASH 290
#define HASH_SLASH 291
#define DOTDOT 292
#define HASH_H 293
#define HASH_S 294
#define HASH_R 295
#define HASH_J 296
#define HASH_SEMI 297
#define HASH_B_QUOTE 298
#define HASH_N 299
#define HASH_T 300
#define WORDS 301
#define WSPLICE 302
#define QWORDS 303
#define QWSPLICE 304
#define SECRET_ESCAPE_R 305
#define SECRET_ESCAPE_E 306
#define SECRET_ESCAPE_I 307
#define SECRET_ESCAPE_J 308
#define OLD_DOTDOT 309
#define NUMBER 310
#define METANUM 311
#define JSKW 312
#define HASH_N_EQUALS 313
#define HASH_N_HASH 314
#define REGCHAR 315
#define REGTOKEN 316
#define LITCHAR 317
#define SPLICE 318
#define JSPLICE 319
#define OLD_AT 320
#define CONSDOT 321
#define LAMBDOT 322
#define UREFDOT 323
#define OREFDOT 324
#define UOREFDOT 325
#define LOW 326
#define ELSE 327
#define ELIF 328




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 108 "parser.y"

  wchar_t *lexeme;
  union obj *val;
  wchar_t chr;
  cnum lineno;



/* Line 293 of yacc.c  */
#line 365 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 377 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  214
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4855

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  100
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  131
/* YYNRULES -- Number of rules.  */
#define YYNRULES  468
/* YYNRULES -- Number of states.  */
#define YYNSTATES  829

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   328

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      94,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    99,     2,    96,    95,     2,    92,    87,    83,
      71,    80,    89,    91,    82,    81,    93,    86,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    97,     2,
       2,     2,     2,    90,    73,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    72,     2,    79,    84,     2,    98,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    75,    85,    76,    88,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    74,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    14,    15,    20,    22,
      24,    25,    30,    32,    35,    36,    40,    41,    46,    47,
      52,    54,    57,    60,    61,    65,    66,    71,    72,    77,
      79,    82,    85,    87,    89,    90,    92,    95,    97,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   126,   130,   134,   140,   146,   150,   154,
     158,   162,   166,   170,   178,   184,   190,   196,   204,   217,
     223,   226,   230,   234,   235,   243,   256,   262,   264,   266,
     268,   270,   273,   276,   280,   284,   294,   300,   307,   308,
     312,   313,   316,   318,   319,   321,   324,   326,   328,   330,
     332,   334,   337,   339,   341,   343,   349,   359,   365,   375,
     381,   384,   387,   390,   393,   398,   401,   404,   407,   412,
     418,   421,   423,   426,   429,   437,   444,   447,   453,   458,
     465,   469,   475,   482,   486,   487,   492,   498,   502,   510,
     516,   523,   531,   540,   543,   549,   554,   561,   567,   569,
     572,   574,   576,   578,   587,   591,   596,   601,   608,   613,
     620,   627,   628,   638,   641,   647,   654,   655,   659,   660,
     662,   663,   666,   668,   669,   671,   674,   676,   679,   681,
     683,   685,   687,   689,   696,   699,   703,   707,   713,   717,
     723,   729,   730,   732,   736,   741,   744,   749,   755,   761,
     764,   767,   769,   771,   773,   775,   777,   779,   784,   787,
     793,   797,   800,   803,   806,   809,   812,   815,   818,   821,
     824,   827,   830,   833,   836,   837,   842,   844,   846,   849,
     853,   856,   861,   864,   869,   870,   874,   875,   879,   880,
     884,   886,   889,   892,   895,   897,   898,   900,   904,   907,
     910,   914,   920,   923,   927,   930,   932,   934,   938,   943,
     946,   951,   956,   959,   962,   965,   968,   971,   976,   980,
     983,   986,   988,   990,   992,   994,   996,   997,   999,  1003,
    1005,  1006,  1010,  1011,  1016,  1017,  1022,  1023,  1029,  1032,
    1035,  1039,  1042,  1046,  1048,  1050,  1052,  1054,  1056,  1058,
    1060,  1062,  1064,  1066,  1068,  1070,  1072,  1074,  1076,  1079,
    1082,  1084,  1087,  1088,  1092,  1093,  1097,  1098,  1102,  1103,
    1107,  1109,  1112,  1114,  1116,  1118,  1120,  1122,  1124,  1126,
    1128,  1130,  1132,  1134,  1136,  1138,  1140,  1142,  1144,  1147,
    1150,  1152,  1155,  1156,  1160,  1161,  1165,  1166,  1170,  1174,
    1179,  1183,  1188,  1192,  1196,  1199,  1202,  1203,  1207,  1209,
    1211,  1212,  1215,  1218,  1220,  1224,  1227,  1231,  1234,  1236,
    1240,  1244,  1247,  1248,  1250,  1253,  1257,  1260,  1263,  1266,
    1270,  1274,  1277,  1280,  1282,  1284,  1286,  1288,  1290,  1292,
    1296,  1299,  1301,  1304,  1306,  1308,  1310,  1314,  1316,  1318,
    1320,  1322,  1324,  1326,  1328,  1330,  1332,  1334,  1336,  1338,
    1340,  1342,  1345,  1348,  1352,  1355,  1358,  1361,  1364,  1367,
    1370,  1374,  1377,  1379,  1382,  1384,  1386,  1388,  1391,  1393,
    1396,  1398,  1401,  1403,  1406,  1408,  1411,  1413,  1416,  1419,
    1421,  1423,  1426,  1429,  1433,  1436,  1440,  1443,  1446,  1448,
    1451,  1454,  1456,  1458,  1460,  1462,  1464,  1466,  1468,  1470,
    1472,  1476,  1480,  1484,  1488,  1492,  1496,  1500,  1506
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     101,     0,    -1,   115,    -1,    50,   209,    -1,    -1,    51,
     105,   102,   113,    -1,    -1,    52,   109,   103,   113,    -1,
      51,    -1,    52,    -1,    -1,    53,   174,   104,   113,    -1,
      53,    -1,     1,    94,    -1,    -1,    42,   106,   200,    -1,
      -1,    42,    93,   107,   200,    -1,    -1,    42,    69,   108,
     200,    -1,   200,    -1,    93,   200,    -1,    69,   200,    -1,
      -1,    42,   110,   194,    -1,    -1,    42,    93,   111,   194,
      -1,    -1,    42,    69,   112,   194,    -1,   194,    -1,    93,
     194,    -1,    69,   194,    -1,   200,    -1,    42,    -1,    -1,
     116,    -1,   114,   116,    -1,   114,    -1,    -1,   117,    -1,
     118,    -1,   119,    -1,   120,    -1,   121,    -1,   122,    -1,
     123,    -1,   127,    -1,   124,    -1,   143,    -1,   144,    -1,
     132,    -1,   146,    -1,   135,    -1,     6,   217,   130,    -1,
       6,   217,     1,    -1,     7,   187,    80,   217,   130,    -1,
       7,   187,    80,   217,     1,    -1,     8,   217,   130,    -1,
       8,   217,     1,    -1,     9,   217,   130,    -1,     9,   217,
       1,    -1,    10,   217,   130,    -1,    10,   217,     1,    -1,
      11,   187,    80,   217,   115,    16,   217,    -1,    11,   187,
      80,   217,     1,    -1,    12,   187,    80,   217,   130,    -1,
      12,   187,    80,   217,     1,    -1,    13,   187,    80,   217,
     125,    16,   217,    -1,    13,   187,    80,   217,   125,   129,
     187,    80,   217,   115,    16,   217,    -1,    13,   187,    80,
     217,     1,    -1,   115,   126,    -1,    14,   217,   125,    -1,
      15,   217,   125,    -1,    -1,   128,   187,    80,   217,   115,
      16,   217,    -1,   128,   187,    80,   217,   115,   129,   187,
      80,   217,   115,    16,   217,    -1,   128,   187,    80,   217,
       1,    -1,    17,    -1,    21,    -1,    18,    -1,    25,    -1,
     115,   131,    -1,    16,   217,    -1,    14,   217,   130,    -1,
      15,   217,   130,    -1,    33,   205,    80,   217,   115,   133,
     134,    16,   217,    -1,    33,   205,    80,   217,     1,    -1,
      78,   205,    80,   217,   115,   133,    -1,    -1,    77,   217,
     115,    -1,    -1,   136,    94,    -1,   137,    -1,    -1,   140,
      -1,   140,   137,    -1,     4,    -1,     3,    -1,   207,    -1,
      26,    -1,   138,    -1,   138,   139,    -1,   139,    -1,   161,
      -1,   182,    -1,    19,   187,    80,   136,    16,    -1,    19,
     187,    80,   136,   129,   187,    80,   136,    16,    -1,    22,
     187,    80,   137,    16,    -1,    22,   187,    80,   137,   129,
     187,    80,   137,    16,    -1,    11,   187,    80,   137,    16,
      -1,    19,     1,    -1,    22,     1,    -1,    11,     1,    -1,
       6,   141,    -1,     7,   187,    80,   141,    -1,     8,   141,
      -1,     9,   141,    -1,    10,   141,    -1,    12,   187,    80,
     141,    -1,    29,   186,    80,   137,    16,    -1,   136,   142,
      -1,    16,    -1,    14,   141,    -1,    15,   141,    -1,    29,
     186,    80,   217,   115,    16,   217,    -1,    29,    80,   217,
     115,    16,   217,    -1,    29,     1,    -1,    29,   186,    80,
     217,     1,    -1,    29,    80,   217,     1,    -1,    30,   217,
     115,   145,    16,   217,    -1,    30,   217,     1,    -1,    31,
      80,   217,   115,   145,    -1,    31,   186,    80,   217,   115,
     145,    -1,    32,   217,   115,    -1,    -1,    31,    80,   217,
       1,    -1,    31,   186,    80,   217,     1,    -1,    32,   217,
       1,    -1,    20,    80,   157,    94,   147,    16,   217,    -1,
      20,    80,   217,    16,   217,    -1,    20,    80,   217,   147,
      16,   217,    -1,    20,   186,    80,   217,   147,    16,   217,
      -1,    20,   186,    80,   157,    94,   147,    16,   217,    -1,
      20,     1,    -1,    20,    80,   157,    94,     1,    -1,    20,
      80,   217,     1,    -1,    20,   186,    80,   157,    94,     1,
      -1,    20,   186,    80,   217,     1,    -1,   148,    -1,   148,
     147,    -1,   149,    -1,   151,    -1,   155,    -1,    21,   205,
      80,   217,   154,   150,    16,   217,    -1,    21,   217,     1,
      -1,    23,   217,   154,   150,    -1,    24,   217,   154,   150,
      -1,    25,   187,    80,   217,   154,   150,    -1,    26,   217,
     154,   150,    -1,    27,   187,    80,   217,   154,   150,    -1,
      28,   187,    80,   217,   154,   150,    -1,    -1,    33,   200,
      80,   217,   154,   152,   153,    16,   217,    -1,    33,    80,
      -1,    33,   200,    80,   217,     1,    -1,    78,   205,    80,
     217,   154,   152,    -1,    -1,    77,   217,   154,    -1,    -1,
     147,    -1,    -1,   156,    94,    -1,   157,    -1,    -1,   158,
      -1,   158,   157,    -1,   230,    -1,   230,   157,    -1,     4,
      -1,     3,    -1,   164,    -1,   185,    -1,   159,    -1,    22,
     205,    80,   156,   160,    16,    -1,    22,     1,    -1,    23,
     156,   160,    -1,    24,   156,   160,    -1,    25,   187,    80,
     156,   160,    -1,    26,   156,   160,    -1,    27,   187,    80,
     156,   160,    -1,    28,   187,    80,   156,   160,    -1,    -1,
       5,    -1,    75,     5,    76,    -1,    75,     5,   163,    76,
      -1,   162,     5,    -1,   162,    75,     5,    76,    -1,   162,
      75,     5,   207,    76,    -1,   162,    75,     5,    55,    76,
      -1,     5,     1,    -1,   162,     1,    -1,    89,    -1,    55,
      -1,   207,    -1,   185,    -1,     5,    -1,     5,    -1,    75,
     200,   205,    76,    -1,     5,     1,    -1,    73,    75,   200,
     205,    76,    -1,    73,    75,     1,    -1,    95,   182,    -1,
      95,     1,    -1,    38,   182,    -1,    38,     1,    -1,    39,
     182,    -1,    39,     1,    -1,    40,   182,    -1,    40,     1,
      -1,    44,   182,    -1,    44,     1,    -1,    45,   182,    -1,
      45,     1,    -1,    41,   174,    -1,    -1,    41,    84,   173,
     174,    -1,    55,    -1,    57,    -1,    96,    96,    -1,    96,
     223,    96,    -1,    72,    79,    -1,    72,   179,   178,    79,
      -1,    75,    76,    -1,    75,   180,   178,    76,    -1,    -1,
      88,   175,   206,    -1,    -1,    64,   176,   206,    -1,    -1,
      58,   177,   174,    -1,    59,    -1,    96,     1,    -1,    72,
       1,    -1,    75,     1,    -1,    82,    -1,    -1,   174,    -1,
     179,    82,   174,    -1,   179,   174,    -1,   179,     1,    -1,
     174,   181,   174,    -1,   180,    82,   174,   181,   174,    -1,
     174,   174,    -1,   180,   174,     1,    -1,   174,     1,    -1,
       5,    -1,    97,    -1,    71,   188,    80,    -1,    71,    93,
     188,    80,    -1,    71,    80,    -1,    71,    67,   200,    80,
      -1,    71,    66,   200,    80,    -1,    71,     1,    -1,    73,
     200,    -1,    73,     1,    -1,    65,   200,    -1,    65,     1,
      -1,    72,    93,   188,    79,    -1,    72,   188,    79,    -1,
      72,    79,    -1,    72,     1,    -1,   182,    -1,   184,    -1,
     183,    -1,   188,    -1,   186,    -1,    -1,   189,    -1,   189,
      66,   200,    -1,   200,    -1,    -1,    42,   190,   200,    -1,
      -1,    42,    93,   191,   200,    -1,    -1,   189,    42,   192,
     200,    -1,    -1,   189,    42,    93,   193,   200,    -1,   189,
     200,    -1,    47,   225,    -1,   189,    47,   225,    -1,    49,
     226,    -1,   189,    49,   226,    -1,     5,    -1,    56,    -1,
      55,    -1,   185,    -1,   166,    -1,   167,    -1,   168,    -1,
     169,    -1,   170,    -1,   171,    -1,   172,    -1,   208,    -1,
     219,    -1,   218,    -1,   220,    -1,    46,   225,    -1,    48,
     226,    -1,   227,    -1,    83,   199,    -1,    -1,    84,   195,
     199,    -1,    -1,    82,   196,   199,    -1,    -1,    63,   197,
     199,    -1,    -1,    58,   198,   199,    -1,    59,    -1,    93,
     194,    -1,   194,    -1,     5,    -1,    56,    -1,    55,    -1,
     185,    -1,   166,    -1,   167,    -1,   168,    -1,   169,    -1,
     170,    -1,   171,    -1,   172,    -1,   208,    -1,   219,    -1,
     218,    -1,   220,    -1,    46,   225,    -1,    48,   226,    -1,
     227,    -1,    83,   206,    -1,    -1,    84,   201,   206,    -1,
      -1,    82,   202,   206,    -1,    -1,    63,   203,   206,    -1,
     200,    37,   200,    -1,   200,    37,    93,   200,    -1,   200,
      54,   200,    -1,   200,    54,    93,   200,    -1,   200,    93,
     200,    -1,   200,    69,   200,    -1,    68,   200,    -1,    70,
     200,    -1,    -1,    58,   204,   206,    -1,    59,    -1,   188,
      -1,    -1,    93,   200,    -1,    69,   200,    -1,   200,    -1,
      86,   209,    86,    -1,    86,     1,    -1,    36,   209,    86,
      -1,    36,     1,    -1,   210,    -1,   209,    85,   209,    -1,
     209,    87,   209,    -1,    88,   209,    -1,    -1,   211,    -1,
     211,   210,    -1,   211,    88,   209,    -1,   211,    89,    -1,
     211,    91,    -1,   211,    90,    -1,   211,    92,   209,    -1,
      72,   212,    79,    -1,    72,    79,    -1,    72,     1,    -1,
      93,    -1,    79,    -1,    81,    -1,    60,    -1,   216,    -1,
       4,    -1,    71,   209,    80,    -1,    71,     1,    -1,   213,
      -1,   213,   212,    -1,   214,    -1,   215,    -1,   216,    -1,
     215,    81,   215,    -1,    90,    -1,    93,    -1,    89,    -1,
      91,    -1,    71,    -1,    80,    -1,    85,    -1,    88,    -1,
      87,    -1,    92,    -1,    86,    -1,    60,    -1,    61,    -1,
      94,    -1,     1,    94,    -1,    96,    96,    -1,    96,   223,
      96,    -1,    96,     1,    -1,    35,     5,    -1,    35,    62,
      -1,    35,     4,    -1,    35,     1,    -1,    98,    98,    -1,
      98,   221,    98,    -1,    98,     1,    -1,   222,    -1,   222,
     221,    -1,   223,    -1,   165,    -1,    56,    -1,    73,   200,
      -1,    62,    -1,    62,   224,    -1,     4,    -1,     4,   224,
      -1,    62,    -1,   224,    62,    -1,     4,    -1,   224,     4,
      -1,    96,    -1,    99,   225,    -1,   223,   225,    -1,     1,
      -1,    98,    -1,    99,   226,    -1,   221,    98,    -1,   221,
      99,   226,    -1,    43,    83,    -1,    43,   228,    83,    -1,
      43,     1,    -1,   228,   229,    -1,   229,    -1,    62,    62,
      -1,    62,     1,    -1,     6,    -1,     7,    -1,     8,    -1,
       9,    -1,    10,    -1,    14,    -1,    15,    -1,    30,    -1,
      32,    -1,    11,   187,    80,    -1,    12,   187,    80,    -1,
      17,   187,    80,    -1,    19,   187,    80,    -1,    13,   187,
      80,    -1,    29,   187,    80,    -1,    31,   187,    80,    -1,
      33,   200,   200,   187,    80,    -1,    20,   187,    80,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   176,   176,   177,   180,   179,   183,   182,   185,   192,
     199,   199,   202,   209,   218,   218,   221,   221,   224,   224,
     227,   228,   229,   232,   232,   235,   235,   238,   238,   241,
     242,   243,   248,   249,   250,   253,   254,   257,   258,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   273,
     274,   275,   276,   279,   281,   285,   288,   294,   296,   300,
     302,   306,   308,   312,   323,   328,   331,   336,   345,   357,
     362,   366,   367,   368,   371,   377,   389,   394,   395,   398,
     399,   402,   405,   406,   407,   410,   433,   437,   450,   453,
     458,   461,   464,   465,   468,   470,   475,   476,   484,   486,
     489,   490,   493,   495,   497,   508,   511,   519,   522,   531,
     534,   536,   538,   540,   541,   543,   544,   545,   546,   549,
     555,   558,   559,   560,   563,   568,   572,   574,   576,   581,
     589,   594,   599,   605,   610,   611,   614,   617,   623,   627,
     629,   632,   644,   649,   651,   654,   657,   660,   665,   666,
     669,   670,   671,   674,   680,   685,   689,   693,   702,   706,
     713,   720,   723,   735,   738,   742,   753,   756,   759,   762,
     763,   765,   768,   770,   773,   774,   775,   776,   779,   781,
     783,   784,   786,   789,   792,   796,   799,   802,   810,   813,
     819,   825,   832,   833,   834,   835,   836,   837,   841,   846,
     849,   853,   856,   857,   859,   861,   864,   869,   878,   883,
     886,   891,   896,   900,   909,   913,   924,   928,   932,   936,
     941,   945,   961,   965,   967,   967,   971,   972,   973,   974,
     976,   977,   983,   984,   990,   990,   995,   995,  1000,  1000,
    1003,  1004,  1006,  1008,  1012,  1014,  1017,  1021,  1030,  1032,
    1036,  1043,  1054,  1055,  1057,  1060,  1064,  1068,  1069,  1075,
    1076,  1077,  1078,  1082,  1087,  1091,  1096,  1100,  1104,  1105,
    1106,  1110,  1111,  1112,  1115,  1118,  1119,  1122,  1126,  1131,
    1134,  1134,  1138,  1138,  1142,  1142,  1145,  1145,  1148,  1151,
    1153,  1157,  1159,  1165,  1166,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,  1186,  1186,  1190,  1190,  1194,  1194,  1198,  1198,
    1201,  1204,  1205,  1207,  1208,  1210,  1211,  1212,  1213,  1214,
    1215,  1216,  1217,  1218,  1219,  1220,  1221,  1222,  1223,  1224,
    1225,  1226,  1228,  1228,  1232,  1232,  1236,  1236,  1240,  1243,
    1249,  1253,  1259,  1260,  1263,  1264,  1265,  1265,  1268,  1271,
    1272,  1275,  1276,  1277,  1280,  1283,  1288,  1292,  1298,  1301,
    1302,  1303,  1304,  1307,  1308,  1309,  1312,  1313,  1314,  1315,
    1316,  1323,  1324,  1326,  1327,  1328,  1329,  1330,  1331,  1332,
    1333,  1337,  1338,  1341,  1342,  1343,  1346,  1348,  1349,  1350,
    1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1362,
    1376,  1377,  1381,  1382,  1384,  1388,  1401,  1403,  1407,  1412,
    1413,  1416,  1420,  1422,  1426,  1427,  1428,  1430,  1437,  1438,
    1440,  1441,  1444,  1445,  1446,  1447,  1450,  1451,  1452,  1454,
    1458,  1459,  1460,  1462,  1468,  1470,  1473,  1478,  1480,  1484,
    1485,  1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,
    1501,  1503,  1505,  1507,  1509,  1511,  1513,  1515,  1520
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SPACE", "TEXT", "SYMTOK", "ALL", "SOME",
  "NONE", "MAYBE", "CASES", "BLOCK", "CHOOSE", "GATHER", "AND", "OR",
  "END", "COLLECT", "UNTIL", "COLL", "OUTPUT", "REPEAT", "REP", "SINGLE",
  "FIRST", "LAST", "EMPTY", "MOD", "MODLAST", "DEFINE", "TRY", "CATCH",
  "FINALLY", "IF", "ERRTOK", "HASH_BACKSLASH", "HASH_SLASH", "DOTDOT",
  "HASH_H", "HASH_S", "HASH_R", "HASH_J", "HASH_SEMI", "HASH_B_QUOTE",
  "HASH_N", "HASH_T", "WORDS", "WSPLICE", "QWORDS", "QWSPLICE",
  "SECRET_ESCAPE_R", "SECRET_ESCAPE_E", "SECRET_ESCAPE_I",
  "SECRET_ESCAPE_J", "OLD_DOTDOT", "NUMBER", "METANUM", "JSKW",
  "HASH_N_EQUALS", "HASH_N_HASH", "REGCHAR", "REGTOKEN", "LITCHAR",
  "SPLICE", "JSPLICE", "OLD_AT", "CONSDOT", "LAMBDOT", "UREFDOT",
  "OREFDOT", "UOREFDOT", "'('", "'['", "'@'", "LOW", "'{'", "'}'", "ELSE",
  "ELIF", "']'", "')'", "'-'", "','", "'\\''", "'^'", "'|'", "'/'", "'&'",
  "'~'", "'*'", "'?'", "'+'", "'%'", "'.'", "'\\n'", "'#'", "'\"'", "':'",
  "'`'", "' '", "$accept", "spec", "$@1", "$@2", "$@3",
  "hash_semi_or_n_expr", "$@4", "$@5", "$@6", "hash_semi_or_i_expr", "$@7",
  "$@8", "$@9", "byacc_fool", "clauses_rev", "clauses_opt", "clause",
  "all_clause", "some_clause", "none_clause", "maybe_clause",
  "cases_clause", "block_clause", "choose_clause", "gather_clause",
  "gather_parts", "additional_gather_parts", "collect_clause",
  "collect_repeat", "until_last", "clause_parts", "additional_parts",
  "if_clause", "elif_clauses_opt", "else_clause_opt", "line", "elems_opt",
  "elems", "text", "texts", "elem", "clause_parts_h", "additional_parts_h",
  "define_clause", "try_clause", "catch_clauses_opt", "output_clause",
  "out_clauses", "out_clause", "repeat_clause", "repeat_parts_opt",
  "out_if_clause", "out_elif_clauses_opt", "out_else_clause_opt",
  "out_clauses_opt", "o_line", "o_elems_opt", "o_elems", "o_elem",
  "rep_elem", "rep_parts_opt", "var", "var_op", "modifiers", "o_var",
  "q_var", "vector", "hash", "struct", "range", "tnode", "tree", "json",
  "$@10", "json_val", "$@11", "$@12", "$@13", "opt_comma", "json_vals",
  "json_pairs", "json_col", "list", "meta", "dwim", "compound", "exprs",
  "exprs_opt", "n_exprs", "listacc", "$@14", "$@15", "$@16", "$@17",
  "i_expr", "$@18", "$@19", "$@20", "$@21", "i_dot_expr", "n_expr", "$@22",
  "$@23", "$@24", "$@25", "n_exprs_opt", "n_dot_expr", "regex",
  "lisp_regex", "regexpr", "regbranch", "regterm", "regclass",
  "regclassterm", "regrange", "regchar", "regtoken", "newl", "strlit",
  "chrlit", "quasilit", "quasi_items", "quasi_item", "litchars",
  "restlitchar", "wordslit", "wordsqlit", "buflit", "buflit_items",
  "buflit_item", "not_a_clause", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,    40,    91,    64,   326,   123,   125,   327,   328,    93,
      41,    45,    44,    39,    94,   124,    47,    38,   126,    42,
      63,    43,    37,    46,    10,    35,    34,    58,    96,    32
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   100,   101,   101,   102,   101,   103,   101,   101,   101,
     104,   101,   101,   101,   106,   105,   107,   105,   108,   105,
     105,   105,   105,   110,   109,   111,   109,   112,   109,   109,
     109,   109,   113,   113,   113,   114,   114,   115,   115,   116,
     116,   116,   116,   116,   116,   116,   116,   116,   116,   116,
     116,   116,   116,   117,   117,   118,   118,   119,   119,   120,
     120,   121,   121,   122,   122,   123,   123,   124,   124,   124,
     125,   126,   126,   126,   127,   127,   127,   128,   128,   129,
     129,   130,   131,   131,   131,   132,   132,   133,   133,   134,
     134,   135,   136,   136,   137,   137,   138,   138,   138,   138,
     139,   139,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     141,   142,   142,   142,   143,   143,   143,   143,   143,   144,
     144,   145,   145,   145,   145,   145,   145,   145,   146,   146,
     146,   146,   146,   146,   146,   146,   146,   146,   147,   147,
     148,   148,   148,   149,   149,   150,   150,   150,   150,   150,
     150,   150,   151,   151,   151,   152,   152,   153,   153,   154,
     154,   155,   156,   156,   157,   157,   157,   157,   158,   158,
     158,   158,   158,   159,   159,   160,   160,   160,   160,   160,
     160,   160,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   162,   163,   163,   163,   163,   164,   164,   164,   165,
     165,   166,   166,   167,   167,   168,   168,   169,   169,   170,
     170,   171,   171,   172,   173,   172,   174,   174,   174,   174,
     174,   174,   174,   174,   175,   174,   176,   174,   177,   174,
     174,   174,   174,   174,   178,   178,   179,   179,   179,   179,
     180,   180,   180,   180,   180,   181,   181,   182,   182,   182,
     182,   182,   182,   183,   183,   183,   183,   184,   184,   184,
     184,   185,   185,   185,   186,   187,   187,   188,   188,   189,
     190,   189,   191,   189,   192,   189,   193,   189,   189,   189,
     189,   189,   189,   194,   194,   194,   194,   194,   194,   194,
     194,   194,   194,   194,   194,   194,   194,   194,   194,   194,
     194,   194,   195,   194,   196,   194,   197,   194,   198,   194,
     194,   199,   199,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   200,   200,   200,   200,
     200,   200,   201,   200,   202,   200,   203,   200,   200,   200,
     200,   200,   200,   200,   200,   200,   204,   200,   200,   205,
     205,   206,   206,   206,   207,   207,   208,   208,   209,   209,
     209,   209,   209,   210,   210,   210,   211,   211,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
     211,   212,   212,   213,   213,   213,   214,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   216,
     217,   217,   218,   218,   218,   219,   219,   219,   219,   220,
     220,   220,   221,   221,   222,   222,   222,   222,   223,   223,
     223,   223,   224,   224,   224,   224,   225,   225,   225,   225,
     226,   226,   226,   226,   227,   227,   227,   228,   228,   229,
     229,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     4,     0,     4,     1,     1,
       0,     4,     1,     2,     0,     3,     0,     4,     0,     4,
       1,     2,     2,     0,     3,     0,     4,     0,     4,     1,
       2,     2,     1,     1,     0,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     5,     5,     3,     3,     3,
       3,     3,     3,     7,     5,     5,     5,     7,    12,     5,
       2,     3,     3,     0,     7,    12,     5,     1,     1,     1,
       1,     2,     2,     3,     3,     9,     5,     6,     0,     3,
       0,     2,     1,     0,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     5,     9,     5,     9,     5,
       2,     2,     2,     2,     4,     2,     2,     2,     4,     5,
       2,     1,     2,     2,     7,     6,     2,     5,     4,     6,
       3,     5,     6,     3,     0,     4,     5,     3,     7,     5,
       6,     7,     8,     2,     5,     4,     6,     5,     1,     2,
       1,     1,     1,     8,     3,     4,     4,     6,     4,     6,
       6,     0,     9,     2,     5,     6,     0,     3,     0,     1,
       0,     2,     1,     0,     1,     2,     1,     2,     1,     1,
       1,     1,     1,     6,     2,     3,     3,     5,     3,     5,
       5,     0,     1,     3,     4,     2,     4,     5,     5,     2,
       2,     1,     1,     1,     1,     1,     1,     4,     2,     5,
       3,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     0,     4,     1,     1,     2,     3,
       2,     4,     2,     4,     0,     3,     0,     3,     0,     3,
       1,     2,     2,     2,     1,     0,     1,     3,     2,     2,
       3,     5,     2,     3,     2,     1,     1,     3,     4,     2,
       4,     4,     2,     2,     2,     2,     2,     4,     3,     2,
       2,     1,     1,     1,     1,     1,     0,     1,     3,     1,
       0,     3,     0,     4,     0,     4,     0,     5,     2,     2,
       3,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     0,     3,     0,     3,     0,     3,     0,     3,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       1,     2,     0,     3,     0,     3,     0,     3,     3,     4,
       3,     4,     3,     3,     2,     2,     0,     3,     1,     1,
       0,     2,     2,     1,     3,     2,     3,     2,     1,     3,
       3,     2,     0,     1,     2,     3,     2,     2,     2,     3,
       3,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       2,     1,     2,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     3,     2,     2,     2,     2,     2,     2,
       3,     2,     1,     2,     1,     1,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     2,     1,
       1,     2,     2,     3,     2,     3,     2,     2,     1,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     5,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,    97,    96,     0,     0,   276,     0,     0,     0,
       0,   276,   276,    77,     0,     0,    78,     0,    99,     0,
       0,   360,   372,     8,     9,    12,     0,     0,     0,   201,
       0,    37,     2,    35,    39,    40,    41,    42,    43,    44,
      45,    47,    46,   276,    50,    52,     0,    92,   100,   102,
      94,    48,    49,    51,   103,     0,   104,    98,    13,   199,
       0,    93,   276,    93,    93,    93,     0,   276,     0,   410,
       0,   113,     0,   323,     0,     0,     0,     0,     0,     0,
     280,     0,     0,     0,     0,     0,     0,     0,   325,   324,
     356,   358,   346,     0,     0,     0,     0,     0,   344,     0,
     342,     0,     0,     0,   327,   328,   329,   330,   331,   332,
     333,   271,   273,   272,   326,   275,     0,   274,   277,   279,
     334,   336,   335,   337,   340,   115,     0,   116,     0,   117,
       0,   112,     0,     0,     0,   110,     0,   143,     0,     0,
     111,     0,   126,     0,     0,     0,   359,     0,   388,   386,
     409,     0,     0,   384,   385,   372,   383,     3,   368,   373,
     387,    14,     0,     0,     4,    20,   293,    23,     0,     0,
     295,   294,   318,   320,   316,     0,   314,     0,   312,     0,
       6,   297,   298,   299,   300,   301,   302,   303,   296,    29,
     304,   306,   305,   307,   310,   226,   227,   238,   240,   236,
       0,     0,   234,     0,    10,   262,     0,     0,   259,     0,
       0,     0,   365,     0,     1,    36,     0,    91,   101,    95,
     200,   195,     0,   411,     0,     0,     0,     0,    93,    93,
     121,   120,    54,     0,    53,   418,   417,   415,   416,   367,
       0,   214,   213,   216,   215,   218,   217,   224,   223,   282,
       0,   446,     0,   444,     0,   448,   220,   219,   222,   221,
     439,   430,   428,   436,     0,     0,   338,   289,   426,     0,
     440,     0,   425,     0,   422,   424,   339,   291,     0,     0,
     266,   265,   354,   355,   270,   269,     0,     0,   264,   263,
       0,     0,     0,   363,   341,     0,   212,   211,   414,   412,
       0,   421,   419,     0,     0,   284,     0,     0,     0,   288,
       0,     0,     0,     0,    58,    57,    60,    59,    62,    61,
       0,     0,     0,    93,   179,   178,     0,   451,   452,   453,
     454,   455,   276,   276,   276,   456,   457,   276,   276,   276,
       0,   276,   458,   276,   459,     0,     0,     0,   174,   182,
     180,   181,     0,   176,     0,     0,     0,     0,   130,   134,
       0,   390,     0,   382,   408,   401,   381,   402,   403,   407,
     405,   404,   399,   397,   400,   406,   398,     0,   391,   393,
     394,   395,   371,   372,   372,   372,   376,   378,   377,   372,
     374,    18,    16,     0,    22,    21,    34,    27,    25,     0,
     308,   309,     0,     0,    31,     0,     0,   322,   311,     0,
      30,    34,     0,     0,   242,   230,   246,     0,   243,   232,
       0,   245,     0,   241,   228,     0,    34,     0,     0,     0,
     257,   205,   202,   193,     0,   204,   203,   364,     0,     0,
      93,     0,    93,     0,   122,   123,     0,     0,     0,    81,
     366,     0,     0,   281,   450,   449,   445,   447,   434,   432,
     431,   429,   437,   438,     0,   427,   441,   442,     0,   423,
     357,   347,     0,   268,   345,   362,   361,   343,   413,   420,
     114,     0,   286,     0,   290,   292,   278,     0,   348,     0,
     350,   353,   352,     0,     0,   118,     0,     0,     0,   208,
       0,     0,     0,     0,     0,     0,   184,     0,     0,     0,
       0,   360,     0,   175,   145,     0,     0,     0,     0,   148,
     150,   151,   152,     0,   172,   177,     0,     0,     0,   128,
       0,     0,     0,     0,     0,     0,     0,   389,   380,   392,
       0,   369,   370,   375,   379,     0,     0,    15,    33,     5,
      32,     0,     0,    24,   319,   317,   315,   321,   313,     7,
     239,   237,   249,   244,   248,     0,   254,   255,   256,   252,
       0,   244,     0,     0,   235,   229,    11,   261,   260,   258,
     194,     0,     0,   196,     0,    38,    38,    82,   225,   283,
     435,   433,   210,   360,   443,   267,    56,    55,     0,   285,
     349,   351,   109,    64,     0,    66,    65,    69,    73,     0,
     105,    79,    80,   276,   460,   461,   464,   462,   463,   468,
     173,   465,   466,   276,     0,   144,     0,   139,     0,     0,
     163,     0,     0,   149,   171,     0,   147,     0,   107,   276,
       0,   119,   127,     0,     0,     0,     0,     0,    86,    88,
     396,    19,    17,    28,    26,   247,   231,   250,     0,   253,
     233,    76,     0,   198,   197,    83,    84,     0,   287,     0,
       0,     0,    70,     0,   276,     0,   191,     0,   207,     0,
       0,   154,     0,   140,   146,     0,     0,     0,   125,     0,
       0,     0,   137,   133,   129,   360,    90,     0,     0,   276,
     209,    63,    38,    38,    67,     0,    93,   173,   173,   276,
     173,   276,   276,     0,   467,   138,   170,     0,     0,   141,
       0,   124,   135,   134,     0,     0,     0,     0,   251,    74,
       0,    71,    72,     0,     0,   191,   191,     0,   191,     0,
       0,   183,   169,   161,   164,   166,   142,     0,   131,   136,
     134,     0,    38,     0,     0,    38,   106,   185,   186,   173,
     188,   173,   173,     0,     0,   276,     0,   276,   276,     0,
     360,   168,   108,   132,    38,    89,    85,    38,     0,   191,
     191,   191,   170,   170,     0,   170,     0,     0,     0,     0,
       0,     0,    88,     0,     0,   187,   189,   190,   161,   161,
       0,   161,     0,     0,   153,     0,   170,     0,    87,     0,
      68,   155,   156,   170,   158,   170,   170,   170,   167,   162,
      75,   161,   161,   161,   166,   157,   159,   160,   165
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    30,   396,   411,   426,   164,   393,   546,   545,   180,
     399,   552,   551,   549,    31,   233,    33,    34,    35,    36,
      37,    38,    39,    40,    41,   609,   672,    42,    43,   613,
     234,   449,    44,   696,   727,    45,    46,    47,    48,    49,
      50,    71,   231,    51,    52,   535,    53,   742,   519,   520,
     769,   521,   771,   791,   743,   522,   523,   524,   348,   349,
     713,    54,    55,   434,   350,   272,   104,   105,   106,   107,
     108,   109,   110,   451,   204,   422,   413,   412,   565,   417,
     421,   570,   111,   112,   113,   114,   115,   116,   117,   118,
     250,   452,   483,   598,   407,   409,   405,   403,   402,   408,
     119,   295,   290,   279,   278,   147,   294,    57,   120,   157,
     158,   159,   377,   378,   379,   380,   160,    72,   121,   122,
     123,   273,   274,   275,   460,   266,   276,   124,   254,   255,
     353
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -653
static const yytype_int16 yypact[] =
{
    2050,   -86,  -653,  -653,  1243,  2108,  2594,  2108,  2108,  2108,
    1396,  2594,  2594,  -653,  1469,  1542,  -653,  1615,  -653,  1688,
      21,  2594,   528,  2658,  2913,  4027,  1127,    64,  3782,  -653,
      82,  4687,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  2594,  -653,  -653,    23,  -653,    30,  -653,
    4730,  -653,  -653,  -653,  -653,    43,  -653,  -653,  -653,  -653,
      65,  4730,  2594,  4730,  4730,  4730,  1396,  2594,  2594,  -653,
     251,  -653,  3516,  -653,    83,  3918,    25,    35,    51,  3672,
      -4,    24,    54,    56,    61,    61,    41,    41,  -653,  -653,
    -653,  -653,  -653,  1009,  3568,  3568,  1238,  1834,  -653,  2727,
    -653,    57,    37,    46,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  -653,  -653,  -653,    94,  -653,  2321,   273,
    -653,  -653,  -653,  -653,  -653,  -653,  3664,  -653,  3695,  -653,
    3787,  -653,    97,   105,   107,  -653,   119,  -653,  3818,   149,
    -653,   165,  -653,    21,   169,  3894,  -653,   174,  -653,  -653,
    -653,  4565,  3229,  -653,  -653,   528,  -653,     8,  -653,  2844,
    -653,    -8,  3568,  3568,  -653,   273,  -653,    55,    61,    41,
    -653,  -653,  -653,  -653,  -653,  4291,  -653,  4227,  -653,  4291,
    -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    1937,  1956,  -653,    50,  -653,  -653,  3568,  3568,  -653,  2594,
     211,   208,  -653,   203,  -653,  -653,   220,  -653,  -653,  -653,
    -653,  -653,   100,  -653,   221,   223,   231,   238,  4730,  4730,
    -653,  -653,  -653,   345,  -653,  -653,  -653,  -653,  -653,  -653,
     289,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    3568,  -653,    58,  -653,    72,  -653,  -653,  -653,  -653,  -653,
    -653,    68,    59,  -653,    61,    61,  -653,  -653,  -653,  2978,
    -653,    41,  -653,    73,   196,  -653,  -653,  -653,  2727,  2727,
    -653,   273,    -1,    -1,  -653,  -653,  2594,    84,  -653,    81,
    2727,  3568,  3568,   273,  -653,  2727,  -653,  -653,  -653,  -653,
     180,  -653,  -653,   198,  2108,   226,    61,    41,  3568,   273,
    3042,  3106,  3568,  3568,  -653,  -653,  -653,  -653,  -653,  -653,
    2585,  2108,    21,  4730,  -653,  -653,  2142,  -653,  -653,  -653,
    -653,  -653,  2594,  2594,  2594,  -653,  -653,  2594,  2594,  2594,
    1761,  2594,  -653,  2594,  -653,  3568,  3568,   230,  4780,  -653,
    -653,  -653,  2823,  4780,  3818,  4730,  4387,  2585,  -653,   106,
      21,  -653,   219,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  -653,  -653,  -653,  -653,   247,  1255,  -653,
     249,  -653,  -653,   528,   528,   528,  -653,  -653,  -653,   528,
    -653,  -653,  -653,  3568,   273,   273,  3170,  -653,  -653,  4291,
    -653,  -653,  4227,  4227,  -653,  4227,  4291,  -653,  -653,  4227,
    -653,  3170,  4027,  2727,  -653,  -653,  -653,  1058,  -653,  -653,
     901,   913,  2727,  -653,  -653,   244,  3170,   248,   391,   266,
    -653,  -653,  -653,  -653,   272,  -653,  -653,  -653,    21,    -6,
    4730,  4730,  4730,  4730,  -653,  -653,    21,    21,    21,  -653,
    -653,  4027,  3568,   273,  -653,  -653,  -653,  -653,  -653,  -653,
      70,   290,  -653,  -653,  1907,   273,  -653,  -653,    41,  -653,
    -653,  -653,   278,  -653,  -653,    -1,    -1,  -653,  -653,  -653,
    -653,  3927,  -653,  3568,  -653,  -653,   273,  3568,   273,  3568,
      81,    -1,    -1,   352,  4418,  -653,  4019,  2856,   151,  -653,
     297,   299,   300,   307,   309,   311,  -653,   312,   324,   325,
    2385,  2183,  3266,  -653,  -653,    21,  1323,  3307,   395,  4656,
    -653,  -653,  -653,   318,  -653,  -653,   329,  3403,   232,  -653,
     408,   410,  4510,  2454,    21,   411,  4050,  -653,  -653,  -653,
    1950,   346,  -653,  -653,  -653,  3568,  3568,   273,  -653,  -653,
     273,  4291,  4291,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  4027,  -653,   355,  -653,  -653,  -653,  -653,
    4027,  4027,   434,   366,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  3559,   367,  -653,   368,  4687,  4687,  -653,  -653,   273,
    -653,  -653,  -653,  2183,  -653,  -653,  -653,  -653,  3568,   273,
      -1,    -1,  -653,  -653,   422,  -653,  -653,  -653,   201,   304,
    -653,  -653,  -653,  2594,  -653,  -653,  -653,  -653,  -653,  -653,
    4780,  -653,  -653,  2183,   371,  -653,   432,  -653,   373,   455,
    -653,  2252,    21,  -653,  -653,  3440,  -653,   441,  -653,  2594,
      21,  -653,  -653,   442,    21,   379,  4541,    21,  -653,   383,
    -653,   273,   273,  -653,  -653,  -653,  -653,  -653,     7,  -653,
    -653,  -653,   333,  -653,  -653,  -653,  -653,   388,   273,    21,
      21,    21,  -653,    21,  2594,   387,   578,   394,  -653,    21,
      21,  -653,    21,  -653,  -653,   452,    21,   400,  -653,    21,
    4142,    21,  -653,  -653,  -653,  2594,   406,  4027,    21,  2594,
    -653,  -653,  4687,  4687,  -653,   409,  4730,  4780,  4780,  2594,
    4780,  2594,  2594,   470,  -653,  -653,  4656,  2550,    21,  -653,
    4730,  -653,  -653,   106,  4175,   412,    21,   474,  -653,  -653,
     413,  -653,  -653,    21,   475,   578,   578,   424,   578,   425,
     426,  -653,  -653,   633,  -653,   429,  -653,   486,  -653,  -653,
     106,    21,  4687,    21,    21,  4687,  -653,  -653,  -653,  4780,
    -653,  4780,  4780,    21,    21,  2594,    21,  2594,  2594,   495,
    2594,   435,  -653,  -653,  4687,  -653,  -653,  4687,   497,   578,
     578,   578,  4656,  4656,   436,  4656,   437,   439,    21,   440,
      21,   505,   383,   508,    21,  -653,  -653,  -653,   633,   633,
      21,   633,    21,    21,  -653,    21,  4656,    21,  -653,    21,
    -653,  -653,  -653,  4656,  -653,  4656,  4656,  4656,  -653,  -653,
    -653,   633,   633,   633,   429,  -653,  -653,  -653,  -653
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,  -653,
    -653,  -653,  -653,  -347,  -653,    39,   494,  -653,  -653,  -653,
    -653,  -653,  -653,  -653,  -653,  -468,  -653,  -653,  -653,  -519,
     -98,  -653,  -653,  -266,  -653,  -653,    12,   -34,  -653,   481,
    -653,   173,  -653,  -653,  -653,  -652,  -653,  -323,  -653,  -653,
    -467,  -653,  -290,  -653,  -508,  -653,  -597,   -92,  -653,  -653,
    -443,  -653,  -653,  -653,  -653,  -653,   -21,    11,    16,    67,
      76,   188,   362,  -653,   -48,  -653,  -653,  -653,   114,  -653,
    -653,  -120,   142,  -653,  -653,    -9,    -5,   216,   -15,  -653,
    -653,  -653,  -653,  -653,     0,  -653,  -653,  -653,  -653,    27,
     725,  -653,  -653,  -653,  -653,  -333,  -212,  -207,   471,    66,
     381,  -653,   166,  -653,  -653,     5,  -147,    -7,   476,   490,
     537,   -66,  -653,   -42,   284,   -67,   -60,   545,  -653,   293,
    -653
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -373
static const yytype_int16 yytable[] =
{
     126,   128,   130,   181,   436,   381,   146,   507,    58,   639,
     139,   210,   567,   145,   144,   188,   219,    70,   267,    70,
      70,    70,    60,   676,   189,   251,   241,   277,   315,   518,
     317,   248,   319,     2,     3,   182,   243,   303,   298,    32,
     183,   261,   265,   265,   220,   261,   347,   301,   221,   582,
     261,   423,   245,   311,   261,   256,    18,   258,   296,   454,
     300,   391,   260,   227,   559,   261,   470,   471,   312,   211,
     583,   748,   458,    70,   590,    70,    70,    70,   474,   576,
      28,   287,   214,   477,   235,   392,   252,   236,   237,   249,
     674,   184,   313,   383,   213,   384,    26,   268,   773,   262,
     185,   400,   268,   262,   568,   439,    26,   253,   262,   401,
     735,   736,   262,   738,   269,    69,    28,   217,   222,   269,
     455,   459,    26,   262,   397,    26,   265,    26,    26,   351,
     459,   352,   591,   299,   252,   311,   356,   533,   534,   270,
     271,   240,    56,   699,   302,   238,   424,    56,   398,    56,
      56,    56,   416,   420,   181,   456,   181,   263,   181,   223,
     264,   425,   779,   473,   780,   781,   188,   610,   188,   611,
     188,   467,   468,    56,   304,   404,   612,   320,   624,   410,
     125,   127,   129,   628,   359,   321,   182,   322,   182,   626,
     182,   183,    56,   183,   429,   183,   633,   462,   463,   323,
     261,   561,   435,    56,   637,    56,    56,    56,   469,   745,
     574,   466,   186,   431,    56,   670,   671,   362,   242,   244,
     246,   382,   265,   265,   257,   259,   132,   133,   134,   354,
     136,   381,   584,   141,   731,   732,   125,   127,   129,   484,
      70,    70,   184,   297,   184,   355,   184,   485,   638,   357,
     611,   185,   268,   185,   360,   185,   513,   612,   262,   216,
     667,   525,   526,   432,   265,   228,   229,   230,    56,   269,
      56,   472,    56,    93,   798,   799,   478,   801,   224,    26,
      96,    97,   225,   226,   433,   310,   493,    56,   383,   437,
     384,   430,   757,   758,    28,   760,   479,   481,   818,   537,
     438,   440,   311,   441,   383,   821,   384,   822,   823,   824,
     310,   442,   685,   494,   496,   497,    70,   312,   443,   482,
     673,   528,   611,   531,   512,   146,   538,   311,   577,   612,
     540,   811,   812,    70,   814,   498,   795,   796,   797,   351,
     575,   313,   312,   351,   351,   351,   579,   527,   580,   698,
     532,   611,   591,   536,   825,   826,   827,   595,   612,   446,
     447,   448,   725,   186,   560,   186,   313,   186,   602,   564,
      56,    56,   569,   572,   383,   450,   384,   614,   181,   615,
     616,   181,   181,   597,   181,   181,   187,   617,   181,   618,
     188,   619,   620,   188,   188,   530,   188,   188,   606,   553,
     188,   444,   445,   588,   621,   622,   557,   493,   594,   531,
     182,   632,   634,   182,   182,   183,   182,   182,   183,   183,
     182,   183,   183,   635,   640,   183,   641,   647,   310,   554,
     555,   581,   556,   384,   656,   659,   558,   789,   669,   585,
     586,   587,   660,   663,   664,   311,    56,   678,   679,   541,
     542,   543,    70,   680,    70,   544,   681,   686,   689,   691,
     312,   695,    56,    56,   700,    56,   184,   706,   718,   184,
     184,   578,   184,   184,   714,   185,   184,   480,   185,   185,
     720,   185,   185,   726,   313,   185,   741,   665,   666,   733,
     753,   756,   751,   754,   495,   190,   146,    56,    56,    56,
     191,   146,   772,   351,   759,   761,   762,   770,   627,   629,
     351,   788,   790,   794,   192,   655,   800,   802,   351,   803,
     805,   807,   657,   658,   809,   215,   808,   646,   645,   218,
     181,   181,   148,   604,   828,   573,   608,   187,   697,   187,
     390,   187,   188,   188,   539,   650,   461,   457,   500,   501,
     502,   653,   654,   503,   504,   505,     0,   508,     0,   509,
       0,   193,   182,   182,     0,     0,     0,   183,   183,   194,
       0,   643,     0,     0,     0,   649,     0,     0,   146,     0,
       0,     0,    56,    56,    56,    56,     0,   186,   149,   150,
     186,   186,     0,   186,   186,     0,     0,   186,     0,   151,
     152,   707,   708,   709,   710,   711,   712,   153,     0,   154,
       0,   351,     0,   480,     0,   495,   155,     0,   184,   184,
     662,   156,     0,    56,     0,   683,   351,   185,   185,     0,
       0,     0,     0,   688,     0,     0,    56,   690,    56,    56,
     694,     0,     0,     0,     0,     0,   190,     0,   190,   728,
     190,   191,     0,   191,     0,   191,   763,   764,   765,   766,
     767,   768,   701,   702,   703,   192,   704,   192,     0,   192,
       0,     0,   715,   716,    56,   717,     0,     0,    56,   719,
     146,     0,   721,     0,   724,   693,   747,     0,     0,     0,
       0,   729,     0,     0,     0,     0,     0,     0,   351,   351,
       0,   351,     0,     0,     0,     0,     0,   351,   351,     0,
       0,   746,   193,     0,   193,     0,   193,     0,   734,   752,
     194,     0,   194,    56,   194,     0,   755,    56,    56,   723,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   186,
     186,   608,   608,     0,   774,     0,   776,   777,   165,     0,
     351,     0,   351,   351,     0,   146,   782,   783,     0,   785,
       0,   187,     0,   750,   187,   187,     0,   187,   187,     0,
       0,   187,     0,   351,   351,     0,   351,     0,     0,     0,
       0,   804,     0,   806,     0,     0,     0,   810,    56,     0,
       0,   775,     0,   813,   778,   815,   816,   351,   817,     0,
     819,     0,   820,     0,   351,     0,   351,   351,   351,     0,
       0,     0,     0,   792,     0,     0,   793,     0,   281,   282,
     283,     0,   289,     0,   293,     0,     0,     0,     0,   675,
       0,     0,    56,     0,     0,     0,     0,     0,     0,   677,
       0,     0,     0,   309,    56,    56,     0,     0,    56,     0,
       0,     0,     0,     0,     0,   687,     0,     0,     0,     0,
       0,     0,    56,     0,     0,     0,    56,     0,     0,     0,
     190,     0,     0,   190,   190,   191,   190,   190,   191,   191,
     190,   191,   191,     0,     0,   191,     0,   394,   395,   192,
     705,     0,   192,   192,    56,   192,   192,    56,     0,   192,
       0,     0,   566,     0,     0,     0,   567,     0,     0,     0,
       0,     0,     0,   187,   187,   730,    56,     0,     0,    56,
       0,     0,     0,     0,     0,   737,     0,   739,   740,     0,
       0,   427,   428,     0,     0,     0,   193,     0,     0,   193,
     193,     0,   193,   193,   194,     0,   193,   194,   194,     0,
     194,   194,     0,     0,   194,     0,   195,     0,   196,   197,
     198,     0,     0,     0,     0,   199,     0,     0,   195,     0,
     196,   197,   198,   200,     0,   453,   201,   199,     0,     0,
       0,   784,     0,   786,   787,   200,     0,     0,   201,   202,
       0,     0,     0,     0,   465,   571,     0,   203,   568,     0,
       0,   202,     0,   293,   293,     0,     0,     0,     0,   203,
     280,     0,     0,     0,    73,   293,   475,   476,     0,     0,
     293,     0,   190,   190,     0,     0,     0,   191,   191,     0,
       0,     0,     0,   486,     0,   488,   490,   491,   492,     0,
       0,   192,   192,     0,    74,    75,     0,    76,    77,    78,
      79,     0,    81,    82,    83,    84,     0,    86,     0,   562,
       0,     0,     0,     0,    88,    89,     0,    90,    91,     0,
     510,   511,    92,     0,    93,     0,     0,    94,     0,    95,
      26,    96,    97,     0,     0,     0,     0,     0,   193,   193,
       0,    98,    99,   100,     0,     0,   194,   194,     0,     0,
       0,     0,     0,     0,   101,   102,     0,   103,     0,     0,
       0,     0,     0,   195,     0,   196,   197,   198,   547,     0,
       0,   550,   199,     0,     0,     0,     0,     0,   205,     0,
     200,     0,    73,   201,     0,     0,   550,  -245,   293,     0,
     563,     0,     0,     0,     0,     0,   202,   293,     0,     0,
       0,   550,     0,     0,   203,     0,     0,     0,     0,     0,
       0,     0,    74,    75,     0,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,   589,     0,     0,
       0,     0,    88,    89,     0,    90,    91,     0,     0,   593,
      92,     0,    93,   206,   207,    94,     0,    95,    26,    96,
      97,     0,     0,     0,     0,     0,     0,   208,   599,    98,
      99,   100,   600,     0,   601,     0,     0,     0,     0,     0,
     209,     0,   101,   102,     0,   103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   623,     0,     0,     0,   284,
       0,     0,   631,    73,    59,     0,  -192,  -192,  -192,  -192,
    -192,  -192,  -192,  -192,  -192,  -192,     0,  -192,  -192,  -192,
       0,  -192,  -192,     0,     0,  -192,     0,     0,  -192,  -192,
     651,   652,  -192,    74,    75,     0,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     0,     0,
       0,     0,     0,    88,    89,     0,    90,    91,     0,     0,
       0,    92,     0,    93,     0,     0,    94,     0,    95,    26,
      96,    97,     0,     0,  -192,   364,   150,   285,  -192,     0,
      98,    99,   100,   668,    60,     0,   365,     0,    73,  -192,
       0,   286,  -192,   101,   102,   367,   103,  -192,     0,     0,
     368,   369,   370,   371,   372,   373,   374,   375,   376,     0,
       0,     0,     0,     0,     0,     0,   623,     0,    74,    75,
       0,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     0,     0,     0,     0,     0,    88,    89,
       0,    90,    91,     0,     0,     0,    92,     0,    93,     0,
       0,    94,     0,    95,    26,    96,    97,   131,     0,     0,
       0,    73,     0,  -360,     0,    98,    99,   100,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    69,   101,   102,
       0,   103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    74,    75,     0,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,     0,     0,     0,     0,
       0,    88,    89,     0,    90,    91,     0,     0,     0,    92,
       0,    93,     0,     0,    94,     0,    95,    26,    96,    97,
     135,     0,     0,     0,    73,     0,  -276,     0,    98,    99,
     100,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   101,   102,     0,   103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    74,    75,     0,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,     0,
       0,     0,     0,     0,    88,    89,     0,    90,    91,     0,
       0,     0,    92,     0,    93,     0,     0,    94,     0,    95,
      26,    96,    97,   137,     0,     0,     0,    73,     0,  -276,
       0,    98,    99,   100,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   101,   102,     0,   103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    74,    75,     0,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,     0,     0,     0,     0,     0,    88,    89,     0,
      90,    91,     0,     0,     0,    92,     0,    93,     0,     0,
      94,     0,    95,    26,    96,    97,   140,     0,     0,     0,
      73,     0,   138,     0,    98,    99,   100,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   101,   102,     0,
     103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      74,    75,     0,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,     0,     0,     0,     0,     0,
      88,    89,     0,    90,    91,     0,     0,     0,    92,     0,
      93,     0,     0,    94,     0,    95,    26,    96,    97,   142,
       0,     0,     0,    73,     0,  -276,     0,    98,    99,   100,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     101,   102,     0,   103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    74,    75,     0,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,     0,     0,
       0,     0,     0,    88,    89,     0,    90,    91,     0,     0,
       0,    92,     0,    93,     0,     0,    94,     0,    95,    26,
      96,    97,   506,     0,     0,     0,    73,     0,   143,     0,
      98,    99,   100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   101,   102,     0,   103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    74,    75,     0,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,     0,     0,     0,     0,     0,    88,    89,     0,    90,
      91,     0,     0,     0,    92,     0,    93,     0,     0,    94,
       0,    95,    26,    96,    97,   288,     0,     0,     0,    73,
       0,  -360,     0,    98,    99,   100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   101,   102,     0,   103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    74,
      75,     0,    76,    77,    78,    79,     0,    81,    82,    83,
      84,     0,    86,     0,     0,     0,     0,     0,     0,    88,
      89,     0,    90,    91,     0,     0,     0,    92,     0,    93,
       0,     0,    94,     0,    95,    26,    96,    97,   592,     0,
       0,     0,    73,     0,     0,     0,    98,    99,   100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   101,
     102,     0,   103,     0,     0,     0,     0,     0,   414,     0,
       0,     0,    74,    75,     0,    76,    77,    78,    79,     0,
      81,    82,    83,    84,     0,    86,     0,   418,     0,     0,
       0,     0,    88,    89,     0,    90,    91,     0,     0,     0,
      92,     0,    93,     0,     0,    94,     0,    95,    26,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,    98,
      99,   100,   195,     0,   196,   197,   198,     0,     0,     0,
       0,   199,   101,   102,     0,   103,     0,     0,     0,   200,
     364,   195,   201,   196,   197,   198,   415,     0,     0,     0,
     199,   365,     0,     0,     0,   202,     0,     0,   200,     0,
     367,   201,   419,   203,     0,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   202,     0,     0,     0,     0,     0,
     -38,     1,   203,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,     0,     0,     0,    13,     0,    14,
      15,    16,    17,     0,     0,     0,    18,     0,     0,    19,
      20,     0,     0,    21,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    23,    24,    25,     0,     0,     0,     0,     0,    60,
       0,     2,     3,     4,    61,    62,    63,    64,    65,    66,
      67,    26,   -93,   -93,   -93,    27,     0,    14,     0,     0,
      17,     0,     0,     0,    18,     0,    28,    68,     0,    29,
       0,     0,     0,   499,   -93,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,
       0,  -206,  -206,     0,  -206,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,    73,     0,
       0,     0,     0,     0,    28,     0,     0,    29,     0,     0,
       0,     0,    69,     0,     0,     0,     0,  -206,     0,     0,
       0,     0,     0,  -206,  -206,  -206,     0,  -206,    74,    75,
     310,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,     0,     0,     0,  -206,   311,    88,    89,
       0,    90,    91,     0,     0,     0,    92,     0,    93,     0,
       0,    94,   312,    95,    26,    96,    97,    73,     0,     0,
       0,     0,     0,     0,     0,    98,    99,   100,     0,     0,
       0,     0,     0,     0,     0,     0,   313,     0,   101,   102,
       0,   103,     0,     0,     0,     0,     0,    74,    75,   310,
      76,    77,    78,    79,     0,    81,    82,    83,    84,     0,
      86,     0,     0,     0,     0,     0,   311,    88,    89,     0,
      90,    91,     0,     0,     0,    92,     0,    93,     0,     0,
      94,   312,    95,    26,    96,    97,    73,     0,     0,     0,
       0,     0,   682,     0,    98,    99,   100,     0,     0,     0,
       0,     0,     0,     0,     0,   313,     0,   101,   102,     0,
     103,     0,     0,     0,     0,     0,    74,    75,     0,    76,
      77,    78,    79,   305,    81,    82,    83,    84,   306,    86,
     307,     0,     0,     0,     0,     0,    88,    89,     0,    90,
      91,     0,     0,     0,    92,     0,    93,   308,     0,    94,
      73,    95,    26,    96,    97,     0,     0,     0,     0,     0,
       0,     0,     0,    98,    99,   100,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   101,   102,     0,   103,
      74,    75,   310,    76,    77,    78,    79,     0,    81,    82,
      83,    84,     0,    86,     0,     0,     0,     0,     0,   311,
      88,    89,     0,    90,    91,     0,     0,     0,    92,     0,
      93,     0,     0,    94,   312,    95,    26,    96,    97,    73,
       0,     0,     0,     0,     0,     0,     0,    98,    99,   100,
       0,     0,     0,     0,     0,     0,     0,     0,   313,     0,
     101,   102,     0,   103,     0,     0,     0,     0,     0,    74,
      75,     0,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,     0,     0,     0,     0,     0,    88,
      89,     0,    90,    91,     0,     0,     0,    92,     0,    93,
       0,     0,    94,     0,    95,    26,    96,    97,     0,     0,
       0,     0,     0,     0,   644,     0,    98,    99,   100,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   101,
     102,   744,   103,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,  -170,   337,     0,   338,
     339,   516,   340,     0,     0,     0,     0,     0,     0,   341,
     342,   343,   344,   517,     0,     0,    60,     0,     2,     3,
       4,    61,    62,    63,    64,    65,    66,    67,     0,    73,
       0,     0,     0,     0,    14,     0,     0,    17,     0,     0,
       0,    18,     0,     0,    68,    93,     0,     0,     0,     0,
       0,    26,    96,    97,     0,   346,     0,  -170,  -170,    74,
      75,     0,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,  -173,     0,     0,     0,     0,    88,
      89,     0,    90,    91,     0,     0,    26,    92,     0,    93,
      27,     0,    94,    73,    95,    26,    96,    97,     0,     0,
       0,    28,     0,     0,    29,     0,    98,    99,   100,    69,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   101,
     102,     0,   103,    74,    75,     0,    76,    77,    78,    79,
     161,    81,    82,    83,    84,     0,    86,     0,     0,     0,
       0,     0,     0,    88,    89,     0,    90,    91,     0,     0,
       0,    92,     0,    93,     0,     0,    94,   162,    95,    26,
      96,    97,    73,     0,     0,     0,     0,     0,     0,     0,
      98,    99,   100,     0,     0,     0,     0,     0,     0,     0,
       0,   163,     0,   101,   102,     0,   103,     0,     0,     0,
       0,     0,    74,    75,     0,    76,    77,    78,    79,     0,
      81,    82,    83,    84,     0,    86,     0,     0,     0,     0,
       0,     0,    88,    89,     0,    90,    91,     0,     0,     0,
      92,     0,    93,     0,     0,    94,   291,    95,    26,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,    98,
      99,   100,     0,     0,     0,     0,     0,     0,     0,     0,
     292,     0,   101,   102,   514,   103,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   515,
     337,     0,   338,   339,   516,   340,     0,     0,   148,     0,
       0,     0,   341,   342,   343,   344,   517,   607,     0,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     -38,   -38,   -38,    13,   -38,    14,    15,    16,    17,     0,
       0,   -38,    18,     0,     0,    19,    20,     0,    93,    21,
       0,     0,     0,     0,    26,    96,    97,     0,   346,     0,
       0,     0,     0,     0,   149,   150,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   151,   152,  -173,   166,     0,
       0,     0,     0,   153,     0,   154,     0,    26,     0,     0,
       0,    27,   385,   386,   387,   388,   389,   156,     0,     0,
       0,     0,    28,     0,     0,    29,     0,     0,    74,    75,
     -93,    76,    77,    78,    79,   167,    81,    82,    83,   168,
       0,   169,     0,     0,     0,     0,     0,     0,   170,   171,
       0,   172,   173,     0,     0,     0,   174,     0,    93,     0,
       0,     0,   175,    73,    26,    96,    97,     0,     0,     0,
       0,     0,     0,     0,     0,   176,   177,   178,     0,     0,
       0,     0,     0,     0,     0,     0,   179,     0,   101,   102,
       0,   103,     0,    74,    75,     0,    76,    77,    78,    79,
       0,    81,    82,    83,    84,     0,    86,     0,     0,     0,
       0,     0,     0,    88,    89,     0,    90,    91,     0,     0,
       0,    92,     0,    93,     0,     0,    94,    73,    95,    26,
      96,    97,     0,   464,     0,     0,     0,     0,     0,     0,
      98,    99,   100,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   101,   102,     0,   103,    74,    75,     0,
      76,    77,    78,    79,     0,    81,    82,    83,    84,     0,
      86,     0,     0,     0,     0,     0,     0,    88,    89,     0,
      90,    91,     0,     0,     0,    92,     0,    93,     0,     0,
      94,    73,    95,    26,    96,    97,     0,     0,     0,     0,
       0,     0,     0,     0,    98,    99,   100,     0,     0,     0,
       0,     0,     0,     0,     0,   487,     0,   101,   102,     0,
     103,    74,    75,     0,    76,    77,    78,    79,     0,    81,
      82,    83,    84,     0,    86,     0,     0,     0,     0,     0,
       0,    88,    89,     0,    90,    91,     0,     0,     0,    92,
       0,    93,     0,     0,    94,    73,    95,    26,    96,    97,
       0,     0,     0,     0,     0,     0,     0,     0,    98,    99,
     100,     0,     0,     0,     0,     0,     0,     0,     0,   489,
       0,   101,   102,     0,   103,    74,    75,     0,    76,    77,
      78,    79,   548,    81,    82,    83,    84,     0,    86,     0,
       0,     0,     0,     0,     0,    88,    89,     0,    90,    91,
     363,     0,     0,    92,     0,    93,     0,     0,    94,     0,
      95,    26,    96,    97,     0,     0,     0,     0,     0,     0,
       0,     0,    98,    99,   100,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   101,   102,   625,   103,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   516,   340,   364,
     150,     0,     0,     0,     0,   341,   342,   343,   344,   517,
     365,     0,     0,     0,     0,     0,     0,     0,   366,   367,
       0,     0,    73,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,     0,     0,     0,     0,     0,     0,     0,
       0,    93,     0,     0,     0,     0,     0,    26,    96,    97,
       0,   346,    74,    75,     0,    76,    77,    78,    79,     0,
      81,    82,    83,    84,     0,    86,     0,     0,     0,     0,
    -173,     0,    88,    89,     0,    90,    91,     0,     0,     0,
      92,     0,    93,     0,     0,    94,     0,    95,    26,    96,
      97,     0,     0,     0,     0,     0,     0,   630,     0,    98,
      99,   100,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   101,   102,   636,   103,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,     0,
     337,     0,   338,   339,   516,   340,     0,     0,     0,     0,
       0,     0,   341,   342,   343,   344,   517,     0,     0,     0,
       0,   684,     0,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,   516,   340,     0,     0,     0,     0,     0,    93,   341,
     342,   343,   344,   517,    26,    96,    97,     0,   346,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  -173,     0,     0,
       0,     0,     0,     0,     0,    93,     0,     0,     0,     0,
       0,    26,    96,    97,     0,   346,     0,   232,     0,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     -38,   -38,   -38,    13,  -173,    14,    15,    16,    17,     0,
       0,     0,    18,     0,     0,    19,    20,     0,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     661,     0,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    73,     0,   -38,    13,   -38,    14,    15,
      16,    17,     0,     0,   -38,    18,     0,    26,    19,    20,
       0,    27,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    28,    74,    75,    29,    76,    77,    78,    79,
     -93,    81,    82,    83,    84,     0,    86,     0,     0,     0,
       0,     0,     0,    88,    89,     0,    90,    91,     0,     0,
      26,    92,     0,    93,    27,     0,    94,     0,    95,    26,
      96,    97,     0,     0,     0,    28,     0,     0,    29,     0,
      98,    99,   100,   -93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   101,   102,   314,   103,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,   -38,   -38,
     -38,    13,     0,    14,    15,    16,    17,     0,     0,     0,
      18,     0,     0,    19,    20,     0,   316,    21,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,   -38,
     -38,   -38,    13,     0,    14,    15,    16,    17,     0,     0,
       0,    18,     0,     0,    19,    20,     0,   195,    21,   196,
     197,   198,     0,     0,     0,    26,   199,     0,     0,    27,
       0,     0,     0,     0,   200,     0,     0,   201,     0,     0,
      28,     0,     0,    29,     0,     0,   247,     0,   -93,     0,
     202,     0,     0,     0,     0,     0,    26,     0,   203,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,     0,   212,    29,     0,   148,     0,   318,   -93,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,   -38,   -38,   -38,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,     0,    60,
      21,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,     0,   337,     0,   338,   339,     0,
     340,     0,   149,   150,     0,     0,     0,   341,   342,   343,
     344,   345,     0,   151,   152,     0,     0,     0,    26,     0,
       0,   153,    27,   154,     0,     0,     0,  -372,  -372,  -372,
     155,     0,     0,    28,     0,   156,    29,     0,     0,     0,
       0,   -93,     0,    93,     0,     0,     0,     0,     0,    26,
      96,    97,     0,   346,     0,   358,     0,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,     0,     0,
     -38,    13,    69,    14,    15,    16,    17,     0,     0,   239,
      18,     0,   148,    19,    20,   -38,   -38,    21,   596,     0,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,   -38,   -38,   -38,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,     0,     0,
      21,     0,     0,     0,     0,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,     0,     0,   149,   150,
      28,     0,     0,    29,     0,     0,     0,     0,   -93,   151,
     152,     0,     0,     0,     0,     0,     0,   153,    26,   154,
       0,     0,    27,  -372,  -372,  -372,   155,     0,     0,     0,
       0,   156,     0,    28,     0,     0,    29,     0,     0,     0,
     605,   -93,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,   -38,   -38,   -38,    13,     0,    14,    15,
      16,    17,     0,     0,     0,    18,     0,     0,    19,    20,
       0,   648,    21,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,     0,     0,   -38,    13,     0,    14,
      15,    16,    17,     0,     0,     0,    18,     0,     0,    19,
      20,     0,   195,    21,   196,   197,   198,     0,     0,     0,
      26,   199,     0,     0,    27,     0,     0,     0,     0,   200,
       0,     0,   201,     0,     0,    28,     0,     0,    29,     0,
       0,     0,     0,   -93,     0,   202,     0,     0,     0,     0,
       0,    26,     0,   203,     0,    27,     0,   -38,   -38,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,    29,
       0,     0,     0,   722,   -93,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,     0,     0,   -38,    13,
       0,    14,    15,    16,    17,     0,     0,     0,    18,     0,
       0,    19,    20,   -38,   -38,    21,   749,     0,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
       0,   -38,    13,     0,    14,    15,    16,    17,     0,     0,
       0,    18,     0,     0,    19,    20,   -38,   -38,    21,     0,
       0,     0,     0,    26,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,    29,   166,     0,     0,     0,   -93,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,    74,    75,    29,    76,    77,    78,    79,   -93,
      81,    82,    83,   168,     0,   169,     0,     0,     0,     0,
       0,     0,   170,   171,     0,   172,   173,     0,     0,     0,
     174,     0,    93,     0,     0,     0,   166,     0,    26,    96,
      97,     0,     0,     0,     0,     0,     0,     0,     0,   176,
     177,   178,     0,     0,     0,     0,     0,     0,     0,     0,
     406,     0,   101,   102,     0,   103,    74,    75,     0,    76,
      77,    78,    79,     0,    81,    82,    83,   168,     0,   169,
       0,     0,     0,     0,     0,     0,   170,   171,     0,   172,
     173,     0,     0,     0,   174,     0,    93,     0,     0,     0,
       0,     0,    26,    96,    97,     0,     0,     0,     0,     0,
       0,     0,     0,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   101,   102,   529,   103,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,     0,   -38,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,     0,   603,
      21,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,     0,   -38,    13,     0,    14,    15,    16,
      17,     0,     0,     0,    18,     0,     0,    19,    20,     0,
       0,    21,     0,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,    29,     0,     0,     0,
       0,   -93,     0,     0,     0,     0,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,    29,     0,     0,
       0,   642,   -93,     2,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,     0,     0,   -38,    13,     0,    14,
      15,    16,    17,     0,     0,     0,    18,     0,     0,    19,
      20,     0,   692,    21,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,     0,     0,   -38,    13,     0,
      14,    15,    16,    17,     0,     0,   361,    18,     0,   148,
      19,    20,     0,     0,    21,     0,     0,     0,     0,     0,
       0,    26,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,    29,
       0,     0,     0,     0,   -93,     0,     0,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,   149,   150,    28,     0,     0,
      29,     0,     0,     0,     0,   -93,   151,   152,     0,     0,
       0,     0,     0,     0,   153,  -372,   154,     0,     0,     0,
    -372,     0,  -372,   155,     0,     0,     0,     0,   156,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,     0,   337,     0,   338,   339,   516,   340,     0,
       0,     0,     0,     0,     0,   341,   342,   343,   344,   517,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,     0,     0,    13,     0,    14,    15,    16,    17,
       0,     0,     0,    18,     0,     0,    19,    20,     0,     0,
      21,    93,     0,     0,     0,     0,     0,    26,    96,    97,
       0,   346,     0,     2,     3,     4,    61,    62,    63,    64,
      65,    66,    67,     0,     0,     0,     0,     0,     0,    14,
    -173,     0,    17,     0,     0,     0,    18,     0,    26,    68,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,    29,     0,     0,     0,
       0,   -93,     0,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,     0,   337,     0,   338,
     339,    26,   340,     0,     0,    27,     0,     0,     0,   341,
     342,   343,   344,   345,     0,     0,    28,     0,     0,    29,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    93,     0,     0,     0,     0,
       0,    26,    96,    97,     0,   346
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-653))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       7,     8,     9,    24,   211,   152,    21,   340,    94,   528,
      15,    26,     5,    20,    19,    24,    50,     5,    85,     7,
       8,     9,     1,   620,    24,     1,     1,    87,   126,   352,
     128,    79,   130,     3,     4,    24,     1,   103,     1,     0,
      24,     4,    84,    85,     1,     4,   138,     1,     5,    55,
       4,     1,     1,    54,     4,     1,    26,     1,     1,     1,
     102,    69,     1,    68,   411,     4,   278,   279,    69,     5,
      76,   723,     4,    61,     4,    63,    64,    65,   290,   426,
      86,    96,     0,   295,     1,    93,    62,     4,     5,    93,
     609,    24,    93,    85,    28,    87,    71,    56,   750,    62,
      24,   168,    56,    62,    97,     5,    71,    83,    62,   169,
     707,   708,    62,   710,    73,    94,    86,    94,    75,    73,
      62,    62,    71,    62,    69,    71,   168,    71,    71,   138,
      62,   138,    62,    96,    62,    54,   143,    31,    32,    98,
      99,    75,     0,   662,    98,    62,    96,     5,    93,     7,
       8,     9,   200,   201,   175,    83,   177,    96,   179,    94,
      99,   203,   759,    79,   761,   762,   175,    16,   177,    18,
     179,    98,    99,    31,    80,   175,    25,    80,   511,   179,
       7,     8,     9,   516,   145,    80,   175,    80,   177,   512,
     179,   175,    50,   177,   209,   179,   519,   264,   265,    80,
       4,   413,   211,    61,   527,    63,    64,    65,   274,   717,
     422,   271,    24,     5,    72,    14,    15,   151,    76,    77,
      78,   155,   264,   265,    82,    83,    10,    11,    12,    80,
      14,   378,   439,    17,   702,   703,    63,    64,    65,   306,
     228,   229,   175,   101,   177,    80,   179,   307,    16,    80,
      18,   175,    56,   177,    80,   179,   348,    25,    62,    43,
     593,   353,   354,    55,   306,    14,    15,    16,   126,    73,
     128,   286,   130,    65,   782,   783,    96,   785,    62,    71,
      72,    73,    66,    67,    76,    37,   320,   145,    85,    86,
      87,    80,   735,   736,    86,   738,    98,   304,   806,    80,
      80,    80,    54,    80,    85,   813,    87,   815,   816,   817,
      37,    80,   635,   320,   321,   322,   304,    69,    80,    93,
      16,   355,    18,   357,    94,   340,    79,    54,    80,    25,
      81,   798,   799,   321,   801,   323,   779,   780,   781,   348,
      96,    93,    69,   352,   353,   354,    80,   354,    76,    16,
     357,    18,    62,   360,   821,   822,   823,    79,    25,    14,
      15,    16,   695,   175,   412,   177,    93,   179,    16,   417,
     228,   229,   420,   421,    85,    86,    87,    80,   399,    80,
      80,   402,   403,   481,   405,   406,    24,    80,   409,    80,
     399,    80,    80,   402,   403,   356,   405,   406,   496,   399,
     409,   228,   229,   451,    80,    80,   406,   441,   468,   443,
     399,    16,    94,   402,   403,   399,   405,   406,   402,   403,
     409,   405,   406,    94,    16,   409,    16,    16,    37,   402,
     403,   438,   405,    87,    79,     1,   409,   770,    16,   446,
     447,   448,    76,    76,    76,    54,   304,    76,    16,   383,
     384,   385,   440,    80,   442,   389,     1,    16,    16,    80,
      69,    78,   320,   321,    76,   323,   399,    80,    16,   402,
     403,    80,   405,   406,    80,   399,   409,   304,   402,   403,
      80,   405,   406,    77,    93,   409,    16,   585,   586,    80,
      16,    16,    80,    80,   321,    24,   511,   355,   356,   357,
      24,   516,    16,   512,    80,    80,    80,    78,   515,   516,
     519,    16,    77,    16,    24,   563,    80,    80,   527,    80,
      80,    16,   570,   571,    16,    31,   792,   534,   533,    48,
     551,   552,     4,   494,   824,   421,   497,   175,   658,   177,
     159,   179,   551,   552,   378,   540,   262,   254,   332,   333,
     334,   551,   552,   337,   338,   339,    -1,   341,    -1,   343,
      -1,    24,   551,   552,    -1,    -1,    -1,   551,   552,    24,
      -1,   532,    -1,    -1,    -1,   536,    -1,    -1,   593,    -1,
      -1,    -1,   440,   441,   442,   443,    -1,   399,    60,    61,
     402,   403,    -1,   405,   406,    -1,    -1,   409,    -1,    71,
      72,    23,    24,    25,    26,    27,    28,    79,    -1,    81,
      -1,   620,    -1,   440,    -1,   442,    88,    -1,   551,   552,
     581,    93,    -1,   481,    -1,   632,   635,   551,   552,    -1,
      -1,    -1,    -1,   640,    -1,    -1,   494,   644,   496,   497,
     647,    -1,    -1,    -1,    -1,    -1,   175,    -1,   177,   697,
     179,   175,    -1,   177,    -1,   179,    23,    24,    25,    26,
      27,    28,   669,   670,   671,   175,   673,   177,    -1,   179,
      -1,    -1,   679,   680,   532,   682,    -1,    -1,   536,   686,
     695,    -1,   689,    -1,   691,   646,   720,    -1,    -1,    -1,
      -1,   698,    -1,    -1,    -1,    -1,    -1,    -1,   707,   708,
      -1,   710,    -1,    -1,    -1,    -1,    -1,   716,   717,    -1,
      -1,   718,   175,    -1,   177,    -1,   179,    -1,   706,   726,
     175,    -1,   177,   581,   179,    -1,   733,   585,   586,   690,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   551,
     552,   702,   703,    -1,   751,    -1,   753,   754,    23,    -1,
     759,    -1,   761,   762,    -1,   770,   763,   764,    -1,   766,
      -1,   399,    -1,   724,   402,   403,    -1,   405,   406,    -1,
      -1,   409,    -1,   782,   783,    -1,   785,    -1,    -1,    -1,
      -1,   788,    -1,   790,    -1,    -1,    -1,   794,   646,    -1,
      -1,   752,    -1,   800,   755,   802,   803,   806,   805,    -1,
     807,    -1,   809,    -1,   813,    -1,   815,   816,   817,    -1,
      -1,    -1,    -1,   774,    -1,    -1,   777,    -1,    93,    94,
      95,    -1,    97,    -1,    99,    -1,    -1,    -1,    -1,   613,
      -1,    -1,   690,    -1,    -1,    -1,    -1,    -1,    -1,   623,
      -1,    -1,    -1,   118,   702,   703,    -1,    -1,   706,    -1,
      -1,    -1,    -1,    -1,    -1,   639,    -1,    -1,    -1,    -1,
      -1,    -1,   720,    -1,    -1,    -1,   724,    -1,    -1,    -1,
     399,    -1,    -1,   402,   403,   399,   405,   406,   402,   403,
     409,   405,   406,    -1,    -1,   409,    -1,   162,   163,   399,
     674,    -1,   402,   403,   752,   405,   406,   755,    -1,   409,
      -1,    -1,     1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      -1,    -1,    -1,   551,   552,   699,   774,    -1,    -1,   777,
      -1,    -1,    -1,    -1,    -1,   709,    -1,   711,   712,    -1,
      -1,   206,   207,    -1,    -1,    -1,   399,    -1,    -1,   402,
     403,    -1,   405,   406,   399,    -1,   409,   402,   403,    -1,
     405,   406,    -1,    -1,   409,    -1,    55,    -1,    57,    58,
      59,    -1,    -1,    -1,    -1,    64,    -1,    -1,    55,    -1,
      57,    58,    59,    72,    -1,   250,    75,    64,    -1,    -1,
      -1,   765,    -1,   767,   768,    72,    -1,    -1,    75,    88,
      -1,    -1,    -1,    -1,   269,    82,    -1,    96,    97,    -1,
      -1,    88,    -1,   278,   279,    -1,    -1,    -1,    -1,    96,
       1,    -1,    -1,    -1,     5,   290,   291,   292,    -1,    -1,
     295,    -1,   551,   552,    -1,    -1,    -1,   551,   552,    -1,
      -1,    -1,    -1,   308,    -1,   310,   311,   312,   313,    -1,
      -1,   551,   552,    -1,    35,    36,    -1,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    -1,     1,
      -1,    -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,
     345,   346,    63,    -1,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,    -1,    -1,    -1,    -1,    -1,   551,   552,
      -1,    82,    83,    84,    -1,    -1,   551,   552,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    57,    58,    59,   393,    -1,
      -1,   396,    64,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      72,    -1,     5,    75,    -1,    -1,   411,    79,   413,    -1,
      82,    -1,    -1,    -1,    -1,    -1,    88,   422,    -1,    -1,
      -1,   426,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,   452,    -1,    -1,
      -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,   464,
      63,    -1,    65,    66,    67,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,   483,    82,
      83,    84,   487,    -1,   489,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    95,    96,    -1,    98,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   510,    -1,    -1,    -1,     1,
      -1,    -1,   517,     5,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    16,
      -1,    18,    19,    -1,    -1,    22,    -1,    -1,    25,    26,
     545,   546,    29,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,
      -1,    63,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    71,    60,    61,    79,    75,    -1,
      82,    83,    84,   598,     1,    -1,    71,    -1,     5,    86,
      -1,    93,    89,    95,    96,    80,    98,    94,    -1,    -1,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   631,    -1,    35,    36,
      -1,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    -1,    55,    56,
      -1,    58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,
      -1,    68,    -1,    70,    71,    72,    73,     1,    -1,    -1,
      -1,     5,    -1,    80,    -1,    82,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    95,    96,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    35,    36,    -1,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,    63,
      -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,    73,
       1,    -1,    -1,    -1,     5,    -1,    80,    -1,    82,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    -1,    98,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,
      -1,    -1,    63,    -1,    65,    -1,    -1,    68,    -1,    70,
      71,    72,    73,     1,    -1,    -1,    -1,     5,    -1,    80,
      -1,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    -1,    98,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,
      58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,
      68,    -1,    70,    71,    72,    73,     1,    -1,    -1,    -1,
       5,    -1,    80,    -1,    82,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      35,    36,    -1,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,
      55,    56,    -1,    58,    59,    -1,    -1,    -1,    63,    -1,
      65,    -1,    -1,    68,    -1,    70,    71,    72,    73,     1,
      -1,    -1,    -1,     5,    -1,    80,    -1,    82,    83,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,
      -1,    63,    -1,    65,    -1,    -1,    68,    -1,    70,    71,
      72,    73,     1,    -1,    -1,    -1,     5,    -1,    80,    -1,
      82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    58,
      59,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,    68,
      -1,    70,    71,    72,    73,     1,    -1,    -1,    -1,     5,
      -1,    80,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    -1,    98,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      56,    -1,    58,    59,    -1,    -1,    -1,    63,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,     1,    -1,
      -1,    -1,     5,    -1,    -1,    -1,    82,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    -1,    98,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    -1,     1,    -1,    -1,
      -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,
      63,    -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,
      83,    84,    55,    -1,    57,    58,    59,    -1,    -1,    -1,
      -1,    64,    95,    96,    -1,    98,    -1,    -1,    -1,    72,
      60,    55,    75,    57,    58,    59,    79,    -1,    -1,    -1,
      64,    71,    -1,    -1,    -1,    88,    -1,    -1,    72,    -1,
      80,    75,    76,    96,    -1,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    88,    -1,    -1,    -1,    -1,    -1,
       0,     1,    96,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    -1,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    -1,    -1,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    71,    14,    15,    16,    75,    -1,    19,    -1,    -1,
      22,    -1,    -1,    -1,    26,    -1,    86,    29,    -1,    89,
      -1,    -1,    -1,     1,    94,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    20,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,     5,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,
      -1,    -1,    94,    -1,    -1,    -1,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    71,    72,    73,    -1,    75,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    -1,    -1,    -1,    94,    54,    55,    56,
      -1,    58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,
      -1,    68,    69,    70,    71,    72,    73,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    96,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    35,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    54,    55,    56,    -1,
      58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,
      68,    69,    70,    71,    72,    73,     5,    -1,    -1,    -1,
      -1,    -1,    80,    -1,    82,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    96,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    58,
      59,    -1,    -1,    -1,    63,    -1,    65,    66,    -1,    68,
       5,    70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    -1,    98,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    -1,    -1,    -1,    -1,    -1,    54,
      55,    56,    -1,    58,    59,    -1,    -1,    -1,    63,    -1,
      65,    -1,    -1,    68,    69,    70,    71,    72,    73,     5,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    84,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      95,    96,    -1,    98,    -1,    -1,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    -1,    55,
      56,    -1,    58,    59,    -1,    -1,    -1,    63,    -1,    65,
      -1,    -1,    68,    -1,    70,    71,    72,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    80,    -1,    82,    83,    84,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,     1,    98,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    29,
      30,    31,    32,    33,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,     5,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    22,    -1,    -1,
      -1,    26,    -1,    -1,    29,    65,    -1,    -1,    -1,    -1,
      -1,    71,    72,    73,    -1,    75,    -1,    77,    78,    35,
      36,    -1,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    94,    -1,    -1,    -1,    -1,    55,
      56,    -1,    58,    59,    -1,    -1,    71,    63,    -1,    65,
      75,    -1,    68,     5,    70,    71,    72,    73,    -1,    -1,
      -1,    86,    -1,    -1,    89,    -1,    82,    83,    84,    94,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    -1,    98,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,
      -1,    63,    -1,    65,    -1,    -1,    68,    69,    70,    71,
      72,    73,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    95,    96,    -1,    98,    -1,    -1,    -1,
      -1,    -1,    35,    36,    -1,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,
      63,    -1,    65,    -1,    -1,    68,    69,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    95,    96,     1,    98,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    19,    20,    21,    22,    -1,    -1,     4,    -1,
      -1,    -1,    29,    30,    31,    32,    33,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    -1,
      -1,    25,    26,    -1,    -1,    29,    30,    -1,    65,    33,
      -1,    -1,    -1,    -1,    71,    72,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    71,    72,    94,     5,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    71,    -1,    -1,
      -1,    75,    88,    89,    90,    91,    92,    93,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    89,    -1,    -1,    35,    36,
      94,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      -1,    58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,
      -1,    -1,    69,     5,    71,    72,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    96,
      -1,    98,    -1,    35,    36,    -1,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,
      -1,    63,    -1,    65,    -1,    -1,    68,     5,    70,    71,
      72,    73,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      82,    83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    -1,    98,    35,    36,    -1,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,
      58,    59,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,
      68,     5,    70,    71,    72,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    95,    96,    -1,
      98,    35,    36,    -1,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,    63,
      -1,    65,    -1,    -1,    68,     5,    70,    71,    72,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    96,    -1,    98,    35,    36,    -1,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    58,    59,
       1,    -1,    -1,    63,    -1,    65,    -1,    -1,    68,    -1,
      70,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,     1,    98,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    17,    -1,    19,    20,    21,    22,    60,
      61,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
      -1,    -1,     5,    -1,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,
      -1,    75,    35,    36,    -1,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,    -1,
      94,    -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,
      63,    -1,    65,    -1,    -1,    68,    -1,    70,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    82,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,     1,    98,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      17,    -1,    19,    20,    21,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    -1,    -1,    65,    29,
      30,    31,    32,    33,    71,    72,    73,    -1,    75,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    72,    73,    -1,    75,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    94,    19,    20,    21,    22,    -1,
      -1,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,     5,    -1,    16,    17,    18,    19,    20,
      21,    22,    -1,    -1,    25,    26,    -1,    71,    29,    30,
      -1,    75,    33,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    35,    36,    89,    38,    39,    40,    41,
      94,    43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,
      71,    63,    -1,    65,    75,    -1,    68,    -1,    70,    71,
      72,    73,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,
      82,    83,    84,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,     1,    98,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    19,    20,    21,    22,    -1,    -1,    -1,
      26,    -1,    -1,    29,    30,    -1,     1,    33,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    19,    20,    21,    22,    -1,    -1,
      -1,    26,    -1,    -1,    29,    30,    -1,    55,    33,    57,
      58,    59,    -1,    -1,    -1,    71,    64,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    72,    -1,    -1,    75,    -1,    -1,
      86,    -1,    -1,    89,    -1,    -1,    84,    -1,    94,    -1,
      88,    -1,    -1,    -1,    -1,    -1,    71,    -1,    96,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    -1,     1,    89,    -1,     4,    -1,     1,    94,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,     1,
      33,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    17,    -1,    19,    20,    -1,
      22,    -1,    60,    61,    -1,    -1,    -1,    29,    30,    31,
      32,    33,    -1,    71,    72,    -1,    -1,    -1,    71,    -1,
      -1,    79,    75,    81,    -1,    -1,    -1,    85,    86,    87,
      88,    -1,    -1,    86,    -1,    93,    89,    -1,    -1,    -1,
      -1,    94,    -1,    65,    -1,    -1,    -1,    -1,    -1,    71,
      72,    73,    -1,    75,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    -1,    -1,
      16,    17,    94,    19,    20,    21,    22,    -1,    -1,     1,
      26,    -1,     4,    29,    30,    31,    32,    33,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    75,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    60,    61,
      86,    -1,    -1,    89,    -1,    -1,    -1,    -1,    94,    71,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    79,    71,    81,
      -1,    -1,    75,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    93,    -1,    86,    -1,    -1,    89,    -1,    -1,    -1,
       1,    94,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    19,    20,
      21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,
      -1,     1,    33,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    16,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,
      30,    -1,    55,    33,    57,    58,    59,    -1,    -1,    -1,
      71,    64,    -1,    -1,    75,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    75,    -1,    -1,    86,    -1,    -1,    89,    -1,
      -1,    -1,    -1,    94,    -1,    88,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    96,    -1,    75,    -1,    77,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    89,
      -1,    -1,    -1,     1,    94,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    16,    17,
      -1,    19,    20,    21,    22,    -1,    -1,    -1,    26,    -1,
      -1,    29,    30,    31,    32,    33,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      -1,    16,    17,    -1,    19,    20,    21,    22,    -1,    -1,
      -1,    26,    -1,    -1,    29,    30,    31,    32,    33,    -1,
      -1,    -1,    -1,    71,    -1,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,
      -1,    89,     5,    -1,    -1,    -1,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
      75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    35,    36,    89,    38,    39,    40,    41,    94,
      43,    44,    45,    46,    -1,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    -1,    58,    59,    -1,    -1,    -1,
      63,    -1,    65,    -1,    -1,    -1,     5,    -1,    71,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,
      83,    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    95,    96,    -1,    98,    35,    36,    -1,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    58,
      59,    -1,    -1,    -1,    63,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    71,    72,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    83,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    95,    96,     1,    98,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,     1,
      33,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    16,    17,    -1,    19,    20,    21,
      22,    -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,
      -1,     1,    94,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    16,    17,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    26,    -1,    -1,    29,
      30,    -1,     1,    33,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    16,    17,    -1,
      19,    20,    21,    22,    -1,    -1,     1,    26,    -1,     4,
      29,    30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,    -1,    89,
      -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    75,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    86,    -1,    -1,
      89,    -1,    -1,    -1,    -1,    94,    71,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
      85,    -1,    87,    88,    -1,    -1,    -1,    -1,    93,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    -1,    17,    -1,    19,    20,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    17,    -1,    19,    20,    21,    22,
      -1,    -1,    -1,    26,    -1,    -1,    29,    30,    -1,    -1,
      33,    65,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,
      -1,    75,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    19,
      94,    -1,    22,    -1,    -1,    -1,    26,    -1,    71,    29,
      -1,    -1,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    94,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    17,    -1,    19,
      20,    71,    22,    -1,    -1,    75,    -1,    -1,    -1,    29,
      30,    31,    32,    33,    -1,    -1,    86,    -1,    -1,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    72,    73,    -1,    75
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    17,    19,    20,    21,    22,    26,    29,
      30,    33,    50,    51,    52,    53,    71,    75,    86,    89,
     101,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   127,   128,   132,   135,   136,   137,   138,   139,
     140,   143,   144,   146,   161,   162,   182,   207,    94,     1,
       1,     6,     7,     8,     9,    10,    11,    12,    29,    94,
     136,   141,   217,     5,    35,    36,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    55,    56,
      58,    59,    63,    65,    68,    70,    72,    73,    82,    83,
      84,    95,    96,    98,   166,   167,   168,   169,   170,   171,
     172,   182,   183,   184,   185,   186,   187,   188,   189,   200,
     208,   218,   219,   220,   227,   141,   217,   141,   217,   141,
     217,     1,   187,   187,   187,     1,   187,     1,    80,   186,
       1,   187,     1,    80,   186,   217,   188,   205,     4,    60,
      61,    71,    72,    79,    81,    88,    93,   209,   210,   211,
     216,    42,    69,    93,   105,   200,     5,    42,    46,    48,
      55,    56,    58,    59,    63,    69,    82,    83,    84,    93,
     109,   166,   167,   168,   169,   170,   171,   172,   185,   194,
     208,   218,   219,   220,   227,    55,    57,    58,    59,    64,
      72,    75,    88,    96,   174,     1,    66,    67,    80,    93,
     188,     5,     1,   209,     0,   116,   187,    94,   139,   137,
       1,     5,    75,    94,   187,   187,   187,   186,    14,    15,
      16,   142,     1,   115,   130,     1,     4,     5,    62,     1,
     209,     1,   182,     1,   182,     1,   182,    84,   174,    93,
     190,     1,    62,    83,   228,   229,     1,   182,     1,   182,
       1,     4,    62,    96,    99,   223,   225,   225,    56,    73,
      98,    99,   165,   221,   222,   223,   226,   226,   204,   203,
       1,   200,   200,   200,     1,    79,    93,   188,     1,   200,
     202,    69,    93,   200,   206,   201,     1,   182,     1,    96,
     223,     1,    98,   221,    80,    42,    47,    49,    66,   200,
      37,    54,    69,    93,     1,   130,     1,   130,     1,   130,
      80,    80,    80,    80,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    17,    19,    20,
      22,    29,    30,    31,    32,    33,    75,   157,   158,   159,
     164,   185,   217,   230,    80,    80,   217,    80,     1,   115,
      80,     1,   209,     1,    60,    71,    79,    80,    85,    86,
      87,    88,    89,    90,    91,    92,    93,   212,   213,   214,
     215,   216,   209,    85,    87,    88,    89,    90,    91,    92,
     210,    69,    93,   106,   200,   200,   102,    69,    93,   110,
     225,   226,   198,   197,   194,   196,    93,   194,   199,   195,
     194,   103,   177,   176,     1,    79,   174,   179,     1,    76,
     174,   180,   175,     1,    96,   223,   104,   200,   200,   188,
      80,     5,    55,    76,   163,   185,   207,    86,    80,     5,
      80,    80,    80,    80,   141,   141,    14,    15,    16,   131,
      86,   173,   191,   200,     1,    62,    83,   229,     4,    62,
     224,   224,   225,   225,    75,   200,   226,    98,    99,   221,
     206,   206,   188,    79,   206,   200,   200,   206,    96,    98,
     141,   217,    93,   192,   225,   226,   200,    93,   200,    93,
     200,   200,   200,   137,   217,   141,   217,   217,   136,     1,
     187,   187,   187,   187,   187,   187,     1,   205,   187,   187,
     200,   200,    94,   157,     1,    16,    21,    33,   147,   148,
     149,   151,   155,   156,   157,   157,   157,   217,   137,     1,
     115,   137,   217,    31,    32,   145,   217,    80,    79,   212,
      81,   209,   209,   209,   209,   108,   107,   200,    42,   113,
     200,   112,   111,   194,   199,   199,   199,   194,   199,   113,
     174,   206,     1,    82,   174,   178,     1,     5,    97,   174,
     181,    82,   174,   178,   206,    96,   113,    80,    80,    80,
      76,   217,    55,    76,   207,   217,   217,   217,   174,   200,
       4,    62,     1,   200,   226,    79,     1,   130,   193,   200,
     200,   200,    16,     1,   115,     1,   130,     1,   115,   125,
      16,    18,    25,   129,    80,    80,    80,    80,    80,    80,
      80,    80,    80,   200,   205,     1,   147,   217,   205,   217,
      80,   200,    16,   147,    94,    94,     1,   147,    16,   129,
      16,    16,     1,   115,    80,   186,   217,    16,     1,   115,
     215,   200,   200,   194,   194,   174,    79,   174,   174,     1,
      76,     1,   115,    76,    76,   130,   130,   205,   200,    16,
      14,    15,   126,    16,   129,   187,   156,   187,    76,    16,
      80,     1,    80,   217,     1,   147,    16,   187,   217,    16,
     217,    80,     1,   115,   217,    78,   133,   181,    16,   129,
      76,   217,   217,   217,   217,   187,    80,    23,    24,    25,
      26,    27,    28,   160,    80,   217,   217,   217,    16,   217,
      80,   217,     1,   115,   217,   205,    77,   134,   174,   217,
     187,   125,   125,    80,   136,   156,   156,   187,   156,   187,
     187,    16,   147,   154,     1,   154,   217,   137,   145,     1,
     115,    80,   217,    16,    80,   217,    16,   160,   160,    80,
     160,    80,    80,    23,    24,    25,    26,    27,    28,   150,
      78,   152,    16,   145,   217,   115,   217,   217,   115,   156,
     156,   156,   217,   217,   187,   217,   187,   187,    16,   205,
      77,   153,   115,   115,    16,   160,   160,   160,   154,   154,
      80,   154,    80,    80,   217,    80,   217,    16,   133,    16,
     217,   150,   150,   217,   150,   217,   217,   217,   154,   217,
     217,   154,   154,   154,   154,   150,   150,   150,   152
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (scnr, parser, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, scnr)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, scnr, parser); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, scnr, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (scnr);
  YYUSE (parser);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, scnr, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scnr, parser);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, scanner_t *scnr, parser_t *parser)
#else
static void
yy_reduce_print (yyvsp, yyrule, scnr, parser)
    YYSTYPE *yyvsp;
    int yyrule;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , scnr, parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, scnr, parser); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, scnr, parser)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (scnr);
  YYUSE (parser);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (scanner_t *scnr, parser_t *parser);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (scanner_t *scnr, parser_t *parser)
#else
int
yyparse (scnr, parser)
    scanner_t *scnr;
    parser_t *parser;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 176 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 177 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val));
                                  end_of_regex(scnr); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 180 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val)); YYACCEPT; }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 181 "parser.y"
    { internal_error("notreached"); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 183 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val)); YYACCEPT; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 184 "parser.y"
    { internal_error("notreached"); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 185 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 192 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 199 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val));
                                  YYACCEPT; }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 201 "parser.y"
    { internal_error("notreached"); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 202 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 209 "parser.y"
    { parser->syntax_tree = nil;
                                  if (parser->errors >= 8)
                                    YYABORT;
                                  yyerrok;
                                  yybadtok(yychar, nil); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 218 "parser.y"
    { parser->ignore = 1; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 219 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 221 "parser.y"
    { parser->ignore = 1; }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 222 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 224 "parser.y"
    { parser->ignore = 1; }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 225 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 227 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 228 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 229 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 232 "parser.y"
    { parser->ignore = 1; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 233 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 235 "parser.y"
    { parser->ignore = 1; }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 236 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 238 "parser.y"
    { parser->ignore = 1; }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 239 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 241 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 242 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 243 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 248 "parser.y"
    { internal_error("notreached"); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 249 "parser.y"
    { internal_error("notreached"); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 250 "parser.y"
    { internal_error("notreached"); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 253 "parser.y"
    { (yyval.val) = check_parse_time_action(cons((yyvsp[(1) - (1)].val), nil)); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 254 "parser.y"
    { (yyval.val) = check_parse_time_action(cons((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)));  }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 257 "parser.y"
    { (yyval.val) = us_nreverse((yyvsp[(1) - (1)].val)); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 258 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 261 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 262 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 263 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 264 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 265 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 266 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 267 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 268 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 269 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 270 "parser.y"
    { (yyval.val) = list(define_transform(parser, (yyvsp[(1) - (1)].val)), nao);
                                  rlc(car((yyval.val)), (yyvsp[(1) - (1)].val));
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 273 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 274 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 275 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 276 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 279 "parser.y"
    { (yyval.val) = list(all_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 281 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("all clause")); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 286 "parser.y"
    { (yyval.val) = list(some_s, (yyvsp[(5) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 290 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("some clause")); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 294 "parser.y"
    { (yyval.val) = list(none_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 296 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("none clause")); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 300 "parser.y"
    { (yyval.val) = list(maybe_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 302 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("maybe clause")); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 306 "parser.y"
    { (yyval.val) = list(cases_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 308 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("cases clause")); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 314 "parser.y"
    { val name = first((yyvsp[(2) - (7)].val));
                                          if (gt(length((yyvsp[(2) - (7)].val)), one))
                                            yyerr("block: takes zero or no arguments");
                                          if (name && !bindable(name))
                                            yyerrorf(scnr,
                                                     lit("block: ~s is not a bindable symbol"),
                                                     name, nao);
                                          (yyval.val) = list(block_s, name, (yyvsp[(5) - (7)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (7)].lineno))); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 324 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("block clause")); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 329 "parser.y"
    { (yyval.val) = list(choose_s, (yyvsp[(5) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 332 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("choose clause")); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 338 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (7)].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(pa_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[(5) - (7)].val))), rest((yyvsp[(5) - (7)].val))),
                                                    args, nao);
                                          rl((yyval.val), num((yyvsp[(1) - (7)].lineno))); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 349 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (12)].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(pa_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[(5) - (12)].val))), rest((yyvsp[(5) - (12)].val))),
                                                    args, cons(cdr((yyvsp[(6) - (12)].val)),
                                                             cons((yyvsp[(7) - (12)].val), (yyvsp[(10) - (12)].val))), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (12)].lineno))); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 358 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("gather clause")); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 363 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 366 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 367 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 368 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 372 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (7)].val));
                                            (yyval.val) = list(car((yyvsp[(1) - (7)].val)),
                                                      (yyvsp[(5) - (7)].val), nil, args,
                                                      nao);
                                            rl((yyval.val), cdr((yyvsp[(1) - (7)].val))); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 380 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (12)].val));
                                            if (nilp((yyvsp[(10) - (12)].val)))
                                              yyerr("empty until/last in collect");
                                            (yyval.val) = list(car((yyvsp[(1) - (12)].val)), (yyvsp[(5) - (12)].val),
                                                      cons(cdr((yyvsp[(6) - (12)].val)),
                                                           cons((yyvsp[(7) - (12)].val), (yyvsp[(10) - (12)].val))),
                                                      args, nao);
                                            rl((yyval.val), cdr((yyvsp[(1) - (12)].val)));
                                            rl((yyvsp[(10) - (12)].val), car((yyvsp[(6) - (12)].val))); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 390 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("collect clause")); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 394 "parser.y"
    { (yyval.val) = cons(collect_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 395 "parser.y"
    { (yyval.val) = cons(repeat_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 398 "parser.y"
    { (yyval.val) = cons(num((yyvsp[(1) - (1)].lineno)), until_s); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 399 "parser.y"
    { (yyval.val) = cons(num((yyvsp[(1) - (1)].lineno)), last_s); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 402 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 405 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 406 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 407 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 414 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                  { val xexp = expand_meta((yyvsp[(2) - (9)].val), nil);
                                    val req = rlc(cons(require_s, xexp), (yyvsp[(2) - (9)].val));
                                    val iff = rlc(cons(cons(cons(req, nil), (yyvsp[(5) - (9)].val)), nil), (yyvsp[(2) - (9)].val));
                                    val elifs = (yyvsp[(6) - (9)].val);
                                    val els = cons((yyvsp[(7) - (9)].val), nil);
                                    val cases = nappend2(nappend2(iff, elifs), els);
                                    (yyval.val) = list(cases_s, cases, nao); }
                                  else
                                  { val expr = expand(car((yyvsp[(2) - (9)].val)), nil);
                                    val ifs = (yyvsp[(5) - (9)].val);
                                    val branch = cons(cons(expr, ifs), nil);
                                    val elifs = (yyvsp[(6) - (9)].val);
                                    val els = (yyvsp[(7) - (9)].val);
                                    if (cdr((yyvsp[(2) - (9)].val)))
                                      yyerr("extra expression in if");
                                    (yyval.val) = cons(if_s,
                                              nappend2(branch, nappend2(elifs, els)));
                                    rl((yyval.val), num((yyvsp[(1) - (9)].lineno))); } }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 434 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("if clause")); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 439 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                       { val xexp = expand_meta((yyvsp[(2) - (6)].val), nil);
                                         val req = rlc(cons(require_s, xexp), (yyvsp[(2) - (6)].val));
                                         (yyval.val) = cons(cons(cons(req, nil), (yyvsp[(5) - (6)].val)), (yyvsp[(6) - (6)].val)); }
                                       else
                                       { val expr = expand(car((yyvsp[(2) - (6)].val)), nil);
                                         val elifs = (yyvsp[(5) - (6)].val);
                                         val branch = cons(cons(expr, elifs), nil);
                                         if (cdr((yyvsp[(2) - (6)].val)))
                                           yyerr("extra expression in elif");
                                         (yyval.val) = nappend2(branch, (yyvsp[(6) - (6)].val)); } }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 450 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 454 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                       { (yyval.val) = (yyvsp[(3) - (3)].val); }
                                       else
                                       { (yyval.val) = cons(cons(t, (yyvsp[(3) - (3)].val)), nil); } }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 458 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 461 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 464 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 465 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 468 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 470 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));
                                  rlc((yyval.val), (yyvsp[(1) - (2)].val)); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 475 "parser.y"
    { (yyval.val) = rl(string_own((yyvsp[(1) - (1)].lexeme)), num(parser->lineno)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 476 "parser.y"
    { if ((yyvsp[(1) - (1)].lexeme)[0] == ' ' && (yyvsp[(1) - (1)].lexeme)[1] == 0)
                                  { val spaces = list(oneplus_s,
                                                      chr(' '), nao);
                                    free((yyvsp[(1) - (1)].lexeme));
                                    (yyval.val) = regex_compile(spaces, nil);
                                    rl((yyval.val), num(parser->lineno)); }
                                  else
                                  { (yyval.val) = rl(string_own((yyvsp[(1) - (1)].lexeme)), num(parser->lineno)); }}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 484 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 486 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 489 "parser.y"
    { (yyval.val) = rlc(cons((yyvsp[(1) - (1)].val), nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 490 "parser.y"
    { (yyval.val) = rlc(cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)), (yyvsp[(2) - (2)].val)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 493 "parser.y"
    { (yyval.val) = rlc(cons(text_s, (yyvsp[(1) - (1)].val)), (yyvsp[(1) - (1)].val));
                                  (yyval.val) = rlc(optimize_text((yyval.val)), (yyval.val)); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 495 "parser.y"
    { (yyval.val) = rl((yyvsp[(1) - (1)].val), num(parser->lineno));
                                  match_reg_elem((yyval.val)); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 497 "parser.y"
    { val sym = first((yyvsp[(1) - (1)].val));
                                  if (sym ==  do_s || sym == require_s)
                                    (yyval.val) = rlc(cons(sym,
                                                   expand_forms(rest((yyvsp[(1) - (1)].val)), nil)),
                                              (yyvsp[(1) - (1)].val));
                                  else if (sym == mdo_s)
                                  { eval_intrinsic(cons(progn_s, cdr((yyvsp[(1) - (1)].val))), nil);
                                    (yyval.val) = cons(do_s, nil); }
                                  else
                                  { (yyval.val) = match_expand_elem((yyvsp[(1) - (1)].val));
                                    match_reg_elem((yyval.val)); } }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 508 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (5)].val));
                                          (yyval.val) = list(coll_s, (yyvsp[(4) - (5)].val), nil, args, nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 513 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (9)].val));
                                  (yyval.val) = list(coll_s, (yyvsp[(4) - (9)].val), cons(cdr((yyvsp[(5) - (9)].val)),
                                                             cons((yyvsp[(6) - (9)].val), (yyvsp[(8) - (9)].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno)));
                                  rl((yyvsp[(6) - (9)].val), car((yyvsp[(5) - (9)].val))); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 519 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (5)].val));
                                         (yyval.val) = list(rep_s, (yyvsp[(4) - (5)].val), nil, args, nao);
                                         rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 525 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (9)].val));
                                  (yyval.val) = list(rep_s, (yyvsp[(4) - (9)].val), cons(cdr((yyvsp[(5) - (9)].val)),
                                                            cons((yyvsp[(6) - (9)].val), (yyvsp[(8) - (9)].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno)));
                                  rl((yyvsp[(6) - (9)].val), car((yyvsp[(5) - (9)].val))); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 531 "parser.y"
    { (yyval.val) = list(block_s, car((yyvsp[(2) - (5)].val)),
                                                 cons((yyvsp[(4) - (5)].val), nil), nao);
                                       rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 534 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("coll clause")); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 536 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 538 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 540 "parser.y"
    { (yyval.val) = rl(list(all_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 542 "parser.y"
    { (yyval.val) = rl(list(some_s, t, (yyvsp[(4) - (4)].val), (yyvsp[(2) - (4)].val), nao), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 543 "parser.y"
    { (yyval.val) = rl(list(none_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 544 "parser.y"
    { (yyval.val) = rl(list(maybe_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 545 "parser.y"
    { (yyval.val) = rl(list(cases_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 547 "parser.y"
    { (yyval.val) = list(choose_s, t, (yyvsp[(4) - (4)].val), (yyvsp[(2) - (4)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 550 "parser.y"
    { (yyval.val) = list(define_s, t, (yyvsp[(4) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (5)].lineno)));
                                  match_reg_params(second((yyvsp[(2) - (5)].val))); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 555 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 558 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 559 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 560 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 565 "parser.y"
    { (yyval.val) = list(define_s, (yyvsp[(2) - (7)].val), (yyvsp[(5) - (7)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (7)].lineno)));
                                  match_reg_params(second((yyvsp[(2) - (7)].val))); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 570 "parser.y"
    { (yyval.val) = list(define_s, nil, (yyvsp[(4) - (6)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 572 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define directive")); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 575 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("define")); }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 577 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define")); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 584 "parser.y"
    { (yyval.val) = list(try_s,
                                            flatten(mapcar(func_n1(second),
                                                           (yyvsp[(4) - (6)].val))),
                                            (yyvsp[(3) - (6)].val), (yyvsp[(4) - (6)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 590 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("try clause")); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 596 "parser.y"
    { (yyval.val) = cons(list(catch_s, cons(t, nil),
                                                         (yyvsp[(4) - (5)].val), nao), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 601 "parser.y"
    { (yyval.val) = cons(list(catch_s, (yyvsp[(2) - (6)].val), (yyvsp[(5) - (6)].val), nao),
                                                    (yyvsp[(6) - (6)].val));
                                          process_catch_exprs((yyvsp[(2) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 606 "parser.y"
    { (yyval.val) = cons(list(finally_s, nil,
                                                         (yyvsp[(3) - (3)].val), nao),
                                                    nil);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 610 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 612 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 615 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 618 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("finally clause")); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 625 "parser.y"
    { (yyval.val) = nil;
                                  yyerr("obsolete output syntax: trailing material"); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 628 "parser.y"
    { (yyval.val) = rl(list(output_s, nao), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 631 "parser.y"
    { (yyval.val) = rl(list(output_s, (yyvsp[(4) - (6)].val), nao), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 634 "parser.y"
    { cons_bind (dest, rest, (yyvsp[(2) - (7)].val));
                                  val dest_ex = expand_form_ver(dest, 166);
                                  val args = if3(dest_ex == dest,
                                                 (yyvsp[(2) - (7)].val), cons(dest_ex, rest));
                                  (yyval.val) = list(output_s, (yyvsp[(5) - (7)].val), args, nao);
                                  rl((yyval.val), num((yyvsp[(1) - (7)].lineno)));
                                  { val into_var = second(memql(into_k, args));
                                    val named_var = second(memql(named_k, args));
                                    match_reg_var(into_var);
                                    match_reg_var(named_var); } }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 646 "parser.y"
    { (yyval.val) = nil;
                                  yyerr("invalid combination of old and "
                                               "new syntax in output directive"); }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 649 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output directive")); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 652 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 655 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 658 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 661 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 665 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 666 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));  }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 669 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 670 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 671 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 677 "parser.y"
    { (yyval.val) = repeat_rep_helper(repeat_s,
                                                                 (yyvsp[(2) - (8)].val), (yyvsp[(5) - (8)].val), (yyvsp[(6) - (8)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (8)].lineno))); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 681 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("repeat clause")); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 687 "parser.y"
    { (yyval.val) = cons(cons(single_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 691 "parser.y"
    { (yyval.val) = cons(cons(first_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 695 "parser.y"
    { if ((yyvsp[(2) - (6)].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[(5) - (6)].val)), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 704 "parser.y"
    { (yyval.val) = cons(cons(empty_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 709 "parser.y"
    { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (6)].val), 166),
                                                              (yyvsp[(5) - (6)].val))), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 716 "parser.y"
    { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (6)].val), 166),
                                                              (yyvsp[(5) - (6)].val))), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 720 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 727 "parser.y"
    { val expr = expand((yyvsp[(2) - (9)].val), nil);
                                  val ifs = (yyvsp[(5) - (9)].val);
                                  val branch = cons(cons(expr, ifs), nil);
                                  val elifs = (yyvsp[(6) - (9)].val);
                                  val els = (yyvsp[(7) - (9)].val);
                                  (yyval.val) = cons(if_s,
                                            nappend2(branch, nappend2(elifs, els)));
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno))); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 736 "parser.y"
    { (yyval.val) = nil;
                                  yyerr("if requires expression"); }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 739 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("if clause")); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 745 "parser.y"
    { val expr = expand(car((yyvsp[(2) - (6)].val)), nil);
                                  val elifs = (yyvsp[(5) - (6)].val);
                                  val branch = cons(cons(expr, elifs), nil);
                                  if (null((yyvsp[(2) - (6)].val)))
                                    yyerr("elif requires expression");
                                  else if (cdr((yyvsp[(2) - (6)].val)))
                                    yyerr("extra expression in elif");
                                  (yyval.val) = nappend2(branch, (yyvsp[(6) - (6)].val)); }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 753 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 758 "parser.y"
    { (yyval.val) = cons(cons(t, (yyvsp[(3) - (3)].val)), nil); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 759 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 762 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 763 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 765 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 768 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 770 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 773 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 774 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 775 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 776 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 779 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 781 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 783 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 784 "parser.y"
    { (yyval.val) = rlc(list(expr_s,
                                                 expand((yyvsp[(1) - (1)].val), nil), nao), (yyvsp[(1) - (1)].val)); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 786 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 790 "parser.y"
    { (yyval.val) = repeat_rep_helper(rep_s, (yyvsp[(2) - (6)].val), (yyvsp[(4) - (6)].val), (yyvsp[(5) - (6)].val));
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 792 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("rep clause")); }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 797 "parser.y"
    { (yyval.val) = cons(cons(single_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 800 "parser.y"
    { (yyval.val) = cons(cons(first_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 803 "parser.y"
    { if ((yyvsp[(2) - (5)].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[(4) - (5)].val)), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 811 "parser.y"
    { (yyval.val) = cons(cons(empty_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 815 "parser.y"
    { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (5)].val), 166),
                                                              (yyvsp[(4) - (5)].val))), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 821 "parser.y"
    { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (5)].val), 166),
                                                              (yyvsp[(4) - (5)].val))), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 825 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 832 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(1) - (1)].lexeme), nil), nao); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 833 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (3)].lexeme), nil), nao); }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 834 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (4)].lexeme), nil), (yyvsp[(3) - (4)].val), nao); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 835 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (2)].lexeme), nil), (yyvsp[(1) - (2)].val), nao); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 836 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(3) - (4)].lexeme), nil), (yyvsp[(1) - (4)].val), nao); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 837 "parser.y"
    { (yyval.val) = nil;
                                          free((yyvsp[(3) - (5)].lexeme));
                                          yyerr("longest match "
                                                "not useable with regex"); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 841 "parser.y"
    { (yyval.val) = nil;
                                          free((yyvsp[(3) - (5)].lexeme));
                                          yyerr("longest match "
                                                "not useable with "
                                                "fixed width match"); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 846 "parser.y"
    { (yyval.val) = nil;
                                  free((yyvsp[(1) - (2)].lexeme));
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 849 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 853 "parser.y"
    { (yyval.val) = list(t, nao); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 856 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 857 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 859 "parser.y"
    { (yyval.val) = rlc(cons(expand_meta((yyvsp[(1) - (1)].val), nil),
                                                 nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 861 "parser.y"
    { (yyval.val) = cons(symhlpr((yyvsp[(1) - (1)].lexeme), nil), nil); }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 864 "parser.y"
    { val expr = symhlpr((yyvsp[(1) - (1)].lexeme), nil);
                                  if (!opt_compat || opt_compat > 128)
                                    expr = expand(expr, nil);
                                  (yyval.val) = list(var_s, expr, nao);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 870 "parser.y"
    { if (opt_compat && opt_compat <= 128)
                                  { (yyval.val) = list(var_s,
                                              expand_meta((yyvsp[(2) - (4)].val), nil),
                                              expand_meta((yyvsp[(3) - (4)].val), nil), nao); }
                                  else
                                  { val quasi_var = list(var_s, (yyvsp[(2) - (4)].val), (yyvsp[(3) - (4)].val), nao);
                                    val quasi_items = cons(quasi_var, nil);
                                    (yyval.val) = car(expand_quasi(quasi_items, nil)); } }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 878 "parser.y"
    { (yyval.val) = nil;
                                  free((yyvsp[(1) - (2)].lexeme));
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 884 "parser.y"
    { (yyval.val) = list(var_s, (yyvsp[(3) - (5)].val), (yyvsp[(4) - (5)].val), nao);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 886 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 891 "parser.y"
    { if (parser->quasi_level > 0 && unquotes_occur((yyvsp[(2) - (2)].val), 0))
                                    (yyval.val) = rlc(cons(vector_lit_s,
                                                   cons((yyvsp[(2) - (2)].val), nil)), (yyvsp[(2) - (2)].val));
                                  else
                                    (yyval.val) = rlc(vec_list((yyvsp[(2) - (2)].val)), (yyvsp[(2) - (2)].val)); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 896 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("unassigned/reserved # notation")); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 900 "parser.y"
    { if (parser->ignore)
                                    (yyval.val) = nil;
                                  else if (parser->quasi_level > 0 &&
                                           unquotes_occur((yyvsp[(2) - (2)].val), 0))
                                    (yyval.val) = rl(cons(hash_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno)));
                                  else
                                    (yyval.val) = rl(hash_construct(first((yyvsp[(2) - (2)].val)),
                                                             rest((yyvsp[(2) - (2)].val))),
                                            num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 909 "parser.y"
    { (yyval.val) = nil;
                                    yybadtok(yychar, lit("hash literal")); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 913 "parser.y"
    {  if (parser->ignore)
                                   { (yyval.val) = nil; }
                                   else if ((parser->quasi_level > 0 &&
                                            unquotes_occur((yyvsp[(2) - (2)].val), 0)) ||
                                           (parser->read_unknown_structs &&
                                            !find_struct_type(first((yyvsp[(2) - (2)].val)))))
                                  { (yyval.val) = rl(cons(struct_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
                                  else
                                  { val strct = make_struct_lit(first((yyvsp[(2) - (2)].val)),
                                                                rest((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(strct, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 924 "parser.y"
    { (yyval.val) = nil;
                                    yybadtok(yychar, lit("struct literal")); }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 928 "parser.y"
    { if (length((yyvsp[(2) - (2)].val)) != two)
                                    yyerr("range literal needs two elements");
                                  { val range = rcons(first((yyvsp[(2) - (2)].val)), second((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(range, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 932 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("range literal")); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 936 "parser.y"
    { if (gt(length((yyvsp[(2) - (2)].val)), three))
                                    yyerr("excess elements in tree node");
                                  { val tn = tnode(first((yyvsp[(2) - (2)].val)), second((yyvsp[(2) - (2)].val)),
                                                   third((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(tn, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 941 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("tree node literal")); }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 945 "parser.y"
    { if (parser->ignore)
                                 { (yyval.val) = nil; }
                                 else if (parser->quasi_level > 0 &&
                                          unquotes_occur((yyvsp[(2) - (2)].val), 0))
                                 { (yyval.val) = rl(cons(tree_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
                                 else
                                 { val opts = first((yyvsp[(2) - (2)].val));
                                   val key_fn_name = pop(&opts);
                                   val less_fn_name = pop(&opts);
                                   val equal_fn_name = pop(&opts);
                                   val key_fn = fname_helper(parser, key_fn_name);
                                   val less_fn = fname_helper(parser, less_fn_name);
                                   val equal_fn = fname_helper(parser, equal_fn_name);
                                   val tr = tree(rest((yyvsp[(2) - (2)].val)), key_fn,
                                                 less_fn, equal_fn, t);
                                     (yyval.val) = rl(tr, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 961 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("tree node literal")); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 965 "parser.y"
    { (yyval.val) = list(json_s, quote_s, (yyvsp[(2) - (2)].val), nao);
                                  end_of_json(scnr); }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 967 "parser.y"
    { parser->quasi_level++; }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 968 "parser.y"
    { parser->quasi_level--;
                                  end_of_json(scnr);
                                  (yyval.val) = list(json_s, sys_qquote_s, (yyvsp[(4) - (4)].val), nao); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 971 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 972 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 973 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 974 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 976 "parser.y"
    { (yyval.val) = vector(zero, nil); }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 978 "parser.y"
    { (yyval.val) = if3(vectorp((yyvsp[(2) - (4)].val)),
                                           (yyvsp[(2) - (4)].val),
                                           rl(cons(vector_lit_s,
                                                   cons(nreverse((yyvsp[(2) - (4)].val)), nil)),
                                              (yyvsp[(2) - (4)].val))); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 983 "parser.y"
    { (yyval.val) = make_hash(hash_weak_none, t); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 985 "parser.y"
    { (yyval.val) = if3(hashp((yyvsp[(2) - (4)].val)),
                                           (yyvsp[(2) - (4)].val),
                                           rl(cons(hash_lit_s,
                                                   cons(nil, nreverse((yyvsp[(2) - (4)].val)))),
                                                   (yyvsp[(2) - (4)].val))); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 990 "parser.y"
    { parser->quasi_level--; }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 991 "parser.y"
    { parser->quasi_level++;
                                  end_of_json_unquote(scnr);
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 995 "parser.y"
    { parser->quasi_level--; }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 996 "parser.y"
    { parser->quasi_level++;
                                  end_of_json_unquote(scnr);
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 1000 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 1001 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 1003 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 1004 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON string")); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 1006 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON array")); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 1008 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON hash")); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1012 "parser.y"
    { if (!parser->read_bad_json)
                                    yyerr("trailing comma in JSON array"); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1017 "parser.y"
    { (yyval.val) = if3(parser->quasi_level > 0 &&
                                                   unquotes_occur((yyvsp[(1) - (1)].val), 0),
                                                   cons((yyvsp[(1) - (1)].val), nil),
                                                   vector(one, (yyvsp[(1) - (1)].val))); }
    break;

  case 247:

/* Line 1806 of yacc.c  */
#line 1021 "parser.y"
    { if (consp((yyvsp[(1) - (3)].val)))
                                          { (yyval.val) = cons((yyvsp[(3) - (3)].val), (yyvsp[(1) - (3)].val)); }
                                          else if (parser->quasi_level > 0 &&
                                                   unquotes_occur((yyvsp[(3) - (3)].val), 0))
                                          { val li = list_vec((yyvsp[(1) - (3)].val));
                                            (yyval.val) = cons((yyvsp[(3) - (3)].val), li); }
                                          else
                                          { vec_push((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                            (yyval.val) = (yyvsp[(1) - (3)].val); } }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1030 "parser.y"
    { yyerr("missing comma in JSON array");
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1032 "parser.y"
    { yybadtok(yychar, lit("JSON array"));
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1036 "parser.y"
    { if (parser->quasi_level > 0 &&
                                              (unquotes_occur((yyvsp[(1) - (3)].val), 0) ||
                                               unquotes_occur((yyvsp[(3) - (3)].val), 0)))
                                          { (yyval.val) = cons(list((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao), nil); }
                                          else
                                          { (yyval.val) = make_hash(hash_weak_none, t);
                                            sethash((yyval.val), (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val)); } }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1044 "parser.y"
    { if (consp((yyvsp[(1) - (5)].val)))
                                          { (yyval.val) = cons(list((yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val), nao), (yyvsp[(1) - (5)].val)); }
                                          else if (parser->quasi_level > 0 &&
                                                   ((unquotes_occur((yyvsp[(3) - (5)].val), 0)) ||
                                                    unquotes_occur((yyvsp[(5) - (5)].val), 0)))
                                          { val pa = hash_pairs((yyvsp[(1) - (5)].val));
                                            (yyval.val) = cons(list((yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val), nao), pa); }
                                          else
                                          { sethash((yyvsp[(1) - (5)].val), (yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val));
                                            (yyval.val) = (yyvsp[(1) - (5)].val); } }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1054 "parser.y"
    { yyerr("missing colon in JSON hash"); }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1056 "parser.y"
    { yyerr("missing comma in JSON hash"); }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1057 "parser.y"
    { yybadtok(yychar, lit("JSON hash")); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1060 "parser.y"
    { if ((yyvsp[(1) - (1)].lexeme)[0] == ':' && (yyvsp[(1) - (1)].lexeme)[1] == 0)
                          { (yyval.val) = nil; }
                          else
                          { yybadtok(yychar, lit("JSON hash")); } }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1064 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1068 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (3)].val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1069 "parser.y"
    { val a = car((yyvsp[(3) - (4)].val));
                                  val ur = uref_helper(parser, a);
                                  if (ur == a)
                                    (yyval.val) = (yyvsp[(3) - (4)].val);
                                  else
                                    (yyval.val) = rlc(cons(ur, cdr((yyvsp[(3) - (4)].val))), ur); }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1075 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1076 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (4)].val); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1077 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (4)].val); }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1078 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("expression")); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1082 "parser.y"
    { if (consp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rl(cons(expr_s, cons((yyvsp[(2) - (2)].val), nil)), num((yyvsp[(1) - (2)].lineno)));
                                  else
                                    (yyval.val) = rl(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                            num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1087 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("meta expression")); }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1091 "parser.y"
    { if (consp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rl(cons(expr_s, cons((yyvsp[(2) - (2)].val), nil)), num((yyvsp[(1) - (2)].chr)));
                                  else
                                    (yyval.val) = rl(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                            num((yyvsp[(1) - (2)].chr))); }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1096 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("meta expression")); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1100 "parser.y"
    { val a = car((yyvsp[(3) - (4)].val));
                                  val ur = uref_helper(parser, a);
                                  (yyval.val) = rlcp_tree(cons(dwim_s,
                                                      cons(ur, cdr((yyvsp[(3) - (4)].val)))), ur); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1104 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, (yyvsp[(2) - (3)].val)), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1105 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, nil), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1106 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("DWIM expression")); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1115 "parser.y"
    { (yyval.val) = rlc(expand_meta((yyvsp[(1) - (1)].val), nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 275:

/* Line 1806 of yacc.c  */
#line 1118 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 1119 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 1122 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val)->c.cdr;
                                  (yyvsp[(1) - (1)].val)->c.cdr = nil;
                                  if ((yyval.val)->c.car == nao)
                                    (yyval.val) = (yyval.val)->c.cdr; }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1127 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1131 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val));
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1134 "parser.y"
    { parser->ignore = 1; }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1135 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = cons(nao, nil);
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1138 "parser.y"
    { parser->ignore = 1; }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1139 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = cons(nao, nil);
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1142 "parser.y"
    { parser->ignore = 1; }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1143 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = (yyvsp[(1) - (4)].val); }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1145 "parser.y"
    { parser->ignore = 1; }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1146 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = (yyvsp[(1) - (5)].val); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1148 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(cons((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)->c.cdr), or2((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)->c.cdr));
                                  (yyvsp[(1) - (2)].val)->c.cdr = (yyval.val); }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1151 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(2) - (2)].val); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1154 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(3) - (3)].val), num((yyvsp[(2) - (3)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1157 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(2) - (2)].val); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1160 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(3) - (3)].val), num((yyvsp[(2) - (3)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1165 "parser.y"
    { (yyval.val) = ifnign(symhlpr((yyvsp[(1) - (1)].lexeme), t)); }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1166 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1168 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1169 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1170 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1171 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1172 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1173 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1174 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1175 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1176 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1177 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1178 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1179 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1180 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1181 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1182 "parser.y"
    { (yyval.val) = rl(cons(quasilist_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1183 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1184 "parser.y"
    { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[(2) - (2)].val), nao), (yyvsp[(2) - (2)].val)),
                                          num(parser->lineno)); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1186 "parser.y"
    { parser->quasi_level++; }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1187 "parser.y"
    { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1190 "parser.y"
    { parser->quasi_level--; }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1191 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1194 "parser.y"
    { parser->quasi_level--; }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1195 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1198 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1199 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1201 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1204 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1205 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1207 "parser.y"
    { (yyval.val) = ifnign(symhlpr((yyvsp[(1) - (1)].lexeme), t)); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1208 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1210 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1211 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1212 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1213 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1214 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1215 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1216 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1217 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1218 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1219 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1220 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1221 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1222 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1223 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1224 "parser.y"
    { (yyval.val) = rl(cons(quasilist_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1225 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1226 "parser.y"
    { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[(2) - (2)].val), nao), (yyvsp[(2) - (2)].val)),
                                          num(parser->lineno)); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1228 "parser.y"
    { parser->quasi_level++; }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1229 "parser.y"
    { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1232 "parser.y"
    { parser->quasi_level--; }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1233 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1236 "parser.y"
    { parser->quasi_level--; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1237 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1240 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao),
                                            or2((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val))); }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1244 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (4)].val),
                                                          uref_helper(parser, (yyvsp[(4) - (4)].val)),
                                                          nao),
                                            or2((yyvsp[(1) - (4)].val), (yyvsp[(4) - (4)].val))); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1250 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao),
                                            or2((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val))); }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1254 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (4)].val),
                                                          uref_helper(parser, (yyvsp[(4) - (4)].val)),
                                                          nao),
                                            or2((yyvsp[(1) - (4)].val), (yyvsp[(4) - (4)].val))); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1259 "parser.y"
    { (yyval.val) = qref_helper(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val)); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1260 "parser.y"
    { (yyval.val) = qref_helper(parser,
                                                   cons(t, cons((yyvsp[(1) - (3)].val), nil)),
                                                        (yyvsp[(3) - (3)].val)); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1263 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1264 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1265 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1266 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1268 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1271 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1272 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1275 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1276 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1277 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1280 "parser.y"
    { (yyval.val) = regex_compile((yyvsp[(2) - (3)].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1283 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1289 "parser.y"
    { (yyval.val) = regex_compile((yyvsp[(2) - (3)].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1293 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1298 "parser.y"
    { (yyval.val) = if3(cdr((yyvsp[(1) - (1)].val)),
                                                   cons(compound_s, (yyvsp[(1) - (1)].val)),
                                                   car((yyvsp[(1) - (1)].val))); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1301 "parser.y"
    { (yyval.val) = list(or_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1302 "parser.y"
    { (yyval.val) = list(and_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1303 "parser.y"
    { (yyval.val) = list(compl_s, (yyvsp[(2) - (2)].val), nao); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1304 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1307 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1308 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1309 "parser.y"
    { (yyval.val) = list((yyvsp[(1) - (3)].val), list(compl_s, (yyvsp[(3) - (3)].val), nao), nao); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1312 "parser.y"
    { (yyval.val) = list(zeroplus_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1313 "parser.y"
    { (yyval.val) = list(oneplus_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1314 "parser.y"
    { (yyval.val) = list(optional_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1315 "parser.y"
    { (yyval.val) = list(nongreedy_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1316 "parser.y"
    { if (first((yyvsp[(2) - (3)].val)) == chr('^'))
                                  { if (rest((yyvsp[(2) - (3)].val)))
                                      (yyval.val) = cons(cset_s, rest((yyvsp[(2) - (3)].val)));
                                    else
                                      (yyval.val) = wild_s; }
                                  else
                                    (yyval.val) = cons(set_s, (yyvsp[(2) - (3)].val)); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1323 "parser.y"
    { (yyval.val) = cons(set_s, nil); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1324 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex character class")); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1326 "parser.y"
    { (yyval.val) = wild_s; }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1327 "parser.y"
    { (yyval.val) = chr(']'); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1328 "parser.y"
    { (yyval.val) = chr('-'); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1329 "parser.y"
    { (yyval.val) = chr((yyvsp[(1) - (1)].chr)); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1330 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1331 "parser.y"
    { (yyval.val) = list(compound_s, string_own((yyvsp[(1) - (1)].lexeme)), nao); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1332 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1333 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex subexpression")); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1337 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1338 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1341 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1342 "parser.y"
    { (yyval.val) = chr((yyvsp[(1) - (1)].chr)); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1343 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1346 "parser.y"
    { (yyval.val) = cons(chr((yyvsp[(1) - (3)].chr)), chr((yyvsp[(3) - (3)].chr))); }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1348 "parser.y"
    { (yyval.chr) = '?'; }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1349 "parser.y"
    { (yyval.chr) = '.'; }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1350 "parser.y"
    { (yyval.chr) = '*'; }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1351 "parser.y"
    { (yyval.chr) = '+'; }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1352 "parser.y"
    { (yyval.chr) = '('; }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1353 "parser.y"
    { (yyval.chr) = ')'; }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1354 "parser.y"
    { (yyval.chr) = '|'; }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1355 "parser.y"
    { (yyval.chr) = '~'; }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1356 "parser.y"
    { (yyval.chr) = '&'; }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1357 "parser.y"
    { (yyval.chr) = '%'; }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1358 "parser.y"
    { (yyval.chr) = '/'; }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1359 "parser.y"
    { (yyval.chr) = (yyvsp[(1) - (1)].chr); }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1362 "parser.y"
    { switch ((yyvsp[(1) - (1)].chr))
                                  { case 's':
                                      (yyval.val) = space_k; break;
                                    case 'S':
                                      (yyval.val) = cspace_k; break;
                                    case 'd':
                                      (yyval.val) = digit_k; break;
                                    case 'D':
                                      (yyval.val) = cdigit_k; break;
                                    case 'w':
                                      (yyval.val) = word_char_k; break;
                                    case 'W':
                                      (yyval.val) = cword_char_k; break; }}
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1377 "parser.y"
    { yyerr("newline expected after directive");
                          yyerrok; }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1381 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1382 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 414:

/* Line 1806 of yacc.c  */
#line 1384 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("string literal")); }
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1388 "parser.y"
    { wchar_t ch;
                                  val str = string_own((yyvsp[(2) - (2)].lexeme));
                                  const wchar_t *cstr = c_str(str, nil);

                                  if (cstr[1] == 0)
                                  { ch = cstr[0]; }
                                  else
                                  { ch = char_from_name(cstr);
                                    if (ch == L'!')
                                    { yyerrorf(scnr, lit("unknown character name: ~a"),
                                               str, nao); }}
                                  end_of_char(scnr);
                                  (yyval.val) = chr(ch); }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1401 "parser.y"
    { (yyval.val) = chr((yyvsp[(2) - (2)].chr));
                                  end_of_char(scnr); }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1403 "parser.y"
    { free((yyvsp[(2) - (2)].lexeme));
                                   yyerrorf(scnr,
                                            lit("invalid UTF-8 used as character name"),
                                            nao); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1407 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar,
                                             lit("character literal")); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1412 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1413 "parser.y"
    { (yyval.val) = cons(quasi_s, (yyvsp[(2) - (3)].val));
                                  rlc((yyval.val), (yyvsp[(2) - (3)].val));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1416 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("quasistring")); }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 1420 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                          rl((yyval.val), num(parser->lineno)); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1422 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));
                                          rl((yyval.val), num(parser->lineno)); }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1426 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1427 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1428 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1430 "parser.y"
    { if (integerp((yyvsp[(2) - (2)].val)) || symbolp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rlcp_tree(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                                   (yyvsp[(2) - (2)].val));
                                  else
                                    (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 1437 "parser.y"
    { (yyval.val) = mkstring(one, chr((yyvsp[(1) - (1)].chr))); }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1438 "parser.y"
    { val ch = mkstring(one, chr((yyvsp[(1) - (2)].chr)));
                                  (yyval.val) = string_extend(ch, (yyvsp[(2) - (2)].val), t); }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1440 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme)); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1441 "parser.y"
    { (yyval.val) = string_extend(string_own((yyvsp[(1) - (2)].lexeme)), (yyvsp[(2) - (2)].val), t); }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1444 "parser.y"
    { (yyval.val) = mkstring(one, chr((yyvsp[(1) - (1)].chr))); }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 1445 "parser.y"
    { (yyval.val) = string_extend((yyvsp[(1) - (2)].val), chr((yyvsp[(2) - (2)].chr)), nil); }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 1446 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme)); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1447 "parser.y"
    { (yyval.val) = string_extend((yyvsp[(1) - (2)].val), string_own((yyvsp[(2) - (2)].lexeme)), nil); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1450 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1451 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1452 "parser.y"
    { val word = (yyvsp[(1) - (2)].val);
                                  (yyval.val) = rlc(cons(word, (yyvsp[(2) - (2)].val)), (yyvsp[(1) - (2)].val)); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1454 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("word list")); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1458 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 1459 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1460 "parser.y"
    { val qword = cons(quasi_s, (yyvsp[(1) - (2)].val));
                                   (yyval.val) = rlc(cons(qword, nil), (yyvsp[(1) - (2)].val)); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1464 "parser.y"
    { val qword = cons(quasi_s, (yyvsp[(1) - (3)].val));
                                   (yyval.val) = rlc(cons(qword, (yyvsp[(3) - (3)].val)), (yyvsp[(1) - (3)].val)); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1468 "parser.y"
    { (yyval.val) = make_buf(zero, nil, nil);
                                           end_of_buflit(scnr); }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1470 "parser.y"
    { end_of_buflit(scnr);
                                           buf_trim((yyvsp[(2) - (3)].val));
                                           (yyval.val) = (yyvsp[(2) - (3)].val); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1473 "parser.y"
    { yyerr("unterminated buffer literal");
                                           end_of_buflit(scnr);
                                           yyerrok; }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1478 "parser.y"
    { buf_put_u8((yyvsp[(1) - (2)].val), length_buf((yyval.val)), (yyvsp[(2) - (2)].val));
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1480 "parser.y"
    { (yyval.val) = make_buf(zero, nil, num_fast(512));
                                          buf_put_u8((yyval.val), zero, (yyvsp[(1) - (1)].val)); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1484 "parser.y"
    { (yyval.val) = num((yyvsp[(1) - (2)].chr) << 4 | (yyvsp[(2) - (2)].chr)); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1485 "parser.y"
    { (yyval.val) = zero;
                                          yyerr("unpaired digit in buffer literal");
                                          yyerrok; }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1492 "parser.y"
    { (yyval.val) = mkexp(all_s, nil, num(parser->lineno)); }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 1493 "parser.y"
    { (yyval.val) = mkexp(some_s, nil, num(parser->lineno)); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 1494 "parser.y"
    { (yyval.val) = mkexp(none_s, nil, num(parser->lineno)); }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 1495 "parser.y"
    { (yyval.val) = mkexp(maybe_s, nil, num(parser->lineno)); }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1496 "parser.y"
    { (yyval.val) = mkexp(cases_s, nil, num(parser->lineno)); }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1497 "parser.y"
    { (yyval.val) = mkexp(and_s, nil, num(parser->lineno)); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1498 "parser.y"
    { (yyval.val) = mkexp(or_s, nil, num(parser->lineno)); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1499 "parser.y"
    { (yyval.val) = mkexp(try_s, nil, num(parser->lineno)); }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1500 "parser.y"
    { (yyval.val) = mkexp(finally_s, nil, num(parser->lineno)); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1502 "parser.y"
    { (yyval.val) = mkexp(block_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1504 "parser.y"
    { (yyval.val) = mkexp(choose_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1506 "parser.y"
    { (yyval.val) = mkexp(collect_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1508 "parser.y"
    { (yyval.val) = mkexp(coll_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1510 "parser.y"
    { (yyval.val) = mkexp(gather_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1512 "parser.y"
    { (yyval.val) = mkexp(define_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1514 "parser.y"
    { (yyval.val) = mkexp(catch_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1516 "parser.y"
    { (yyval.val) = mkexp(if_s,
                                                         cons((yyvsp[(2) - (5)].val),
                                                              cons((yyvsp[(3) - (5)].val), (yyvsp[(4) - (5)].val))),
                                                         nil); }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 1521 "parser.y"
    { yyerr("@(output) doesn't nest"); }
    break;



/* Line 1806 of yacc.c  */
#line 6987 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scnr, parser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scnr, parser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, scnr, parser);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, scnr, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scnr, parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scnr, parser);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, scnr, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1525 "parser.y"


const int have_yydebug = YYDEBUG;

int yylex(YYSTYPE *, yyscan_t scanner);

void yydebug_onoff(int val)
{
#if YYDEBUG
  yydebug = val;
#else
  (void) val;
#endif
}

static void set_syntax_tree(parser_t *parser, val tree)
{
  if (tree == nao)
    parser->syntax_tree = tree;
  else
    set(mkloc(parser->syntax_tree, parser->parser), tree);
}

static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed)
{
  scanner_t *scnr = parser->scanner;
  int leading_at = *lexeme == L'@';
  wchar_t *tokfree = lexeme;
  wchar_t *colon = wcschr(lexeme, L':');
  val sym;

  if (leading_at) {
    if (!meta_allowed) {
      val tok = string_own(lexeme);
      yyerrorf(scnr, lit("~a: meta variable not allowed in this context"), tok, nao);
      return nil;
    }
    lexeme++;
  }

  if (colon != 0)
    *colon = 0;

  if (colon == lexeme) {
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern(sym_name, keyword_package);
  } else if (colon != 0) {
    val pkg_name = string(lexeme);
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    if (equal(pkg_name, lit("#"))) {
      sym = make_sym(sym_name);
    } else {
      val package = find_package(pkg_name);
      if (!package) {
        yyerrorf(scnr, lit("~a:~a: package ~a not found"),
                 pkg_name, sym_name, pkg_name, nao);
        return nil;
      }
      sym = intern(sym_name, package);
    }
  } else {
    val sym_name = string(lexeme);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern_fallback(sym_name, cur_package);
  }

  return leading_at ? rl(list(var_s, sym, nao), num(parser->lineno)) : sym;
}

static val expand_repeat_rep_args(val args)
{
  list_collect_decl (out, ptail);
  val exp_pair = nil, exp_pairs = nil;

  for (; args; args = cdr(args)) {
    val arg = car(args);

    if (consp(arg)) {
      if (exp_pairs) {
        list_collect_decl (iout, iptail);
        for (; arg; arg = cdr(arg)) {
          val iarg = car(arg);
          if (consp(iarg)) {
            val sym = first(iarg);
            iptail = list_collect(iptail, list(sym,
                                               expand(second(iarg), nil),
                                               nao));
            match_reg_var(sym);
          } else {
            iptail = list_collect(iptail, iarg);
            match_reg_var(iarg);
          }
        }
        ptail = list_collect(ptail, iout);
      } else if (exp_pair) {
        val sym = first(arg);
        ptail = list_collect(ptail, list(sym,
                                         expand(second(arg), nil),
                                         nao));
        match_reg_var(sym);
      } else {
        ptail = list_collect(ptail, arg);
      }
    } else if (!exp_pair && !exp_pairs) {
      if (arg == counter_k) {
        exp_pair = t;
        ptail = list_collect(ptail, arg);
        continue;
      } else if (arg == vars_k) {
        exp_pairs = t;
        ptail = list_collect(ptail, arg);
        continue;
      }
    } else if (exp_pair) {
      match_reg_var(arg);
    }

    exp_pair = exp_pairs = nil;
    ptail = list_collect(ptail, arg);
  }

  return out;
}

static val extract_vars(val output_spec)
{
  list_collect_decl (vars, tai);

  if (consp(output_spec)) {
    val sym = first(output_spec);
    if (sym == var_s) {
      val expr = second(output_spec);
      val modifiers = third(output_spec);

      if (bindable(expr)) {
        tai = list_collect(tai, expr);
      } else if (opt_compat && opt_compat <= 128) {
        tai = list_collect_nconc(tai, extract_vars(expr));
      } else {
        val frefs = expand_with_free_refs(expr, nil, nil);
        tai = list_collect_nconc(tai, second(frefs));
      }

      for (; modifiers; modifiers = cdr(modifiers)) {
        val mod = car(modifiers);
        if (bindable(mod)) {
          tai = list_collect(tai, mod);
        } else if (consp(mod)) {
          val msym = car(mod);

          if (msym == dwim_s) {
            val arg = second(mod);

            if (bindable(arg)) {
              tai = list_collect(tai, arg);
            } else if (consp(arg) && car(arg) == rcons_s) {
              val f = second(arg);
              val t = third(arg);
              if (bindable(f))
                tai = list_collect(tai, f);
              if (bindable(t))
                tai = list_collect(tai, t);
            }
          }
        }
      }
    } else if (sym == expr_s) {
      val expr = second(output_spec);
      val frefs = expand_with_free_refs(expr, nil, nil);
      tai = list_collect_nconc(tai, second(frefs));
    } else {
      for (; output_spec; output_spec = cdr(output_spec))
        tai = list_collect_nconc(tai, extract_vars(car(output_spec)));
    }
  }

  return vars;
}

static val repeat_rep_helper(val sym, val args, val main, val parts)
{
  uses_or2;
  val exp_args = expand_repeat_rep_args(args);
  val single_parts = nil, single_parts_p = nil;
  val first_parts = nil, first_parts_p = nil;
  val last_parts = nil, last_parts_p = nil;
  val empty_parts = nil, empty_parts_p = nil;
  val mod_parts = nil, mod_parts_p = nil;
  val modlast_parts = nil, modlast_parts_p = nil;
  val occur_vars = nil;
  val iter;

  for (iter = parts; iter != nil; iter = cdr(iter)) {
    val part = car(iter);
    val sym = car(part);
    val clauses = copy_list(cdr(part));

    if (sym == single_s) {
      single_parts = nappend2(single_parts, clauses);
      single_parts_p = t;
    } else if (sym == first_s) {
      first_parts = nappend2(first_parts, clauses);
      first_parts_p = t;
    } else if (sym == last_s) {
      last_parts = nappend2(last_parts, clauses);
      last_parts_p = t;
    } else if (sym == empty_s) {
      empty_parts = nappend2(empty_parts, clauses);
      empty_parts_p = t;
    } else if (sym == mod_s) {
      mod_parts = cons(clauses, mod_parts);
      mod_parts_p = t;
    } else if (sym == modlast_s) {
      modlast_parts = cons(clauses, modlast_parts);
      modlast_parts_p = t;
    } else {
      abort();
    }
  }

  single_parts = or2(single_parts, single_parts_p);
  first_parts = or2(first_parts, first_parts_p);
  last_parts = or2(last_parts, last_parts_p);
  empty_parts = or2(empty_parts, empty_parts_p);
  mod_parts = or2(nreverse(mod_parts), mod_parts_p);
  modlast_parts = or2(nreverse(modlast_parts), modlast_parts_p);

  occur_vars = extract_vars(main);
  occur_vars = nappend2(occur_vars, extract_vars(single_parts));
  occur_vars = nappend2(occur_vars, extract_vars(first_parts));
  occur_vars = nappend2(occur_vars, extract_vars(last_parts));
  occur_vars = nappend2(occur_vars, extract_vars(empty_parts));
  occur_vars = nappend2(occur_vars, extract_vars(mod_parts));
  occur_vars = uniq(occur_vars);

  return list(sym, exp_args, main, single_parts, first_parts,
              last_parts, empty_parts, nreverse(mod_parts),
              nreverse(modlast_parts), occur_vars, nao);
}

static void process_catch_exprs(val exprs)
{
  val params = second(exprs);
  for (; params; params = cdr(params)) {
    val param = first(params);
    if (consp(param))
      match_reg_var(car(param));
    else
      match_reg_var(param);
  }
}

static val define_transform(parser_t *parser, val define_form)
{
  scanner_t *scnr = parser->scanner;
  val sym = first(define_form);
  val args = second(define_form);

  if (define_form == nil)
    return nil;

  assert (sym == define_s);

  if (args == nil) {
    yyerr("define requires arguments");
    return define_form;
  }

  if (!consp(args) || !listp(cdr(args))) {
    yyerr("bad define argument syntax");
    return define_form;
  } else {
    val name = first(args);
    val params = second(args);

    if (!symbolp(name)) {
      yyerr("function name must be a symbol");
      return define_form;
    }

    if (!proper_list_p(params)) {
      yyerr("invalid function parameter list");
      return define_form;
    }

    if (!all_satisfy(params, func_n1(symbolp), nil))
      yyerr("function parameters must be symbols");
  }

  return define_form;
}

static val optimize_text(val text_form)
{
  if (all_satisfy(rest(text_form), func_n1(stringp), nil))
    return cat_str(rest(text_form), lit(""));
  return text_form;
}

static val unquotes_occur(val quoted_form, int level)
{
  uses_or2;

  if (atom(quoted_form)) {
    return nil;
  } else {
    val sym = car(quoted_form);
    if (sym == sys_unquote_s || sym == sys_splice_s)
      return (level == 0) ? t : unquotes_occur(cdr(quoted_form), level - 1);
    if (sym == sys_qquote_s)
      return unquotes_occur(cdr(quoted_form), level + 1);
    return or2(unquotes_occur(sym, level),
               unquotes_occur(cdr(quoted_form), level));
  }
}

val expand_meta(val form, val menv)
{
  val sym;

  if (atom(form))
    return form;

  menv = default_arg(menv, make_env(nil, nil, nil));

  if ((sym = car(form)) == quasi_s) {
    if (opt_compat && opt_compat <= 128) {
      list_collect_decl (out, ptail);

      for (; consp(form); form = cdr(form)) {
        val subform = car(form);
        if (consp(subform) && car(subform) == expr_s)
          ptail = list_collect(ptail, expand_meta(subform, menv));
        else
          ptail = list_collect(ptail, subform);
      }

      ptail = list_collect_nconc(ptail, form);

      return rlcp(out, form);
    }

    return expand(form, nil);
  }

  if ((sym = car(form)) == expr_s) {
    val exp_x = expand(second(form), menv);
    if (!bindable(exp_x))
      return rlcp(cons(sym, cons(exp_x, nil)), form);
    return rlcp(cons(var_s, cons(exp_x, nil)), form);
  }

  if (sym == var_s) {
    val var_x = expand(second(form), menv);
    if (!bindable(var_x))
      return rlcp(cons(expr_s, cons(var_x, nil)), form);
    return rlcp(cons(var_s, cons(var_x, nil)), form);
  }

  {
    list_collect_decl (out, ptail);

    for (; consp(form); form = cdr(form)) {
      loc nptail = list_collect(ptail, expand_meta(car(form), menv));
      rlcp(deref(ptail), form);
      ptail = nptail;
    }

    ptail = list_collect_nconc(ptail, form);

    return out;
  }
}

static val rlviable(val form)
{
  switch (type(form)) {
  case NIL:
  case LIT:
  case CHR:
  case NUM:
  case SYM:
  case BGNUM:
  case FLNUM:
    return nil;
  default:
    return t;
  }
}

val rlset(val form, val info)
{
  if (rlviable(form)) {
    loc place = gethash_l(lit("rlcp"), form_to_ln_hash, form, nulloc);
    if (nilp(deref(place)))
      set(place, info);
  }
  return form;
}

val rlrec(parser_t *parser, val form, val line)
{
  if (parser->rec_source_loc)
    rlset(form, cons(line, parser->name));
  return form;
}

val rlcp_parser(parser_t *parser, val to, val from)
{
  if (parser->rec_source_loc)
    rlset(to, source_loc(from));
  return to;
}

static val rlcp_tree_rec(val to, val from, struct circ_stack *up)
{
  val ret = to;

  while (consp(to)) {
    val a = car(to);
    struct circ_stack rlcs = { up, a };
    rlcp(to, from);
    if (!parser_callgraph_circ_check(up, a))
      break;
    rlcp_tree_rec(a, from, &rlcs);
    to = cdr(to);
    if (!parser_callgraph_circ_check(up, to))
      break;
  }
  return ret;
}


val rlcp_tree(val to, val from)
{
  return rlcp_tree_rec(to, from, 0);
}

static wchar_t char_from_name(const wchar_t *name)
{
  static struct {
    const wchar_t *name;
    const wchar_t ch;
  } map[] = {
    { L"nul", 0 },
    { L"alarm", L'\a' },
    { L"backspace", L'\b' },
    { L"tab", L'\t' },
    { L"linefeed", L'\n' },
    { L"newline", L'\n' },
    { L"vtab", L'\v' },
    { L"page", L'\f' },
    { L"return", L'\r' },
    { L"esc", 27 },
    { L"space", L' ' },
    { L"pnul", 0xDC00 },
    { 0, 0 },
  };
  int i;

  for (i = 0; map[i].name; i++) {
    if (wcscmp(map[i].name, name) == 0)
      return map[i].ch;
  }

  return L'!'; /* code meaning not found */
}

static val make_expr(parser_t *parser, val sym, val rest, val lineno)
{
  val expr = cons(sym, rest);
  val ret = cons(expr_s, cons(expand(expr, nil), nil));

  if (rest) {
    rlc(expr, rest);
    rlc(ret, rest);
  } else {
    rl(expr, lineno);
    rl(ret, lineno);
  }

  return ret;
}

static val check_parse_time_action(val spec_rev)
{
  val line = first(spec_rev);

  if (consp(line)) {
    val elem = first(line);
    if (consp(elem)) {
      val sym = car(elem);
      if (sym == include_s) {
        return nappend2(nreverse(include(line)), rest(spec_rev));
      }
      if (sym == in_package_s) {
        eval_intrinsic(elem, nil);
        return nil;
      }
    }
  }
  return spec_rev;
}

static val uref_helper(parser_t *parser, val expr)
{
  if (consp(expr) && car(expr) == qref_s) {
    return rplaca(expr, uref_s);
  } else {
    return rl(rlc(list(uref_s, expr, nao), expr), num(parser->lineno));
  }
}

static val uoref_helper(parser_t *parser, val expr)
{
  val uref = uref_helper(parser, expr);
  rplacd(uref, cons(t, cdr(uref)));
  return uref;
}

static val qref_helper(parser_t *parser, val lexpr, val rexpr)
{
  uses_or2;

  if (consp(rexpr) && car(rexpr) == qref_s) {
    rplacd(rexpr, rlc(cons(lexpr, cdr(rexpr)), lexpr));
    return rl(rexpr, num(parser->lineno));
  } else {
    return rl(rlc(list(qref_s, lexpr, rexpr, nao),
                  or2(lexpr, rexpr)),
                  num(parser->lineno));
  }
}

static val fname_helper(parser_t *parser, val name)
{
  if (!name) {
    return nil;
  } else if (!bindable(name)) {
    yyerrorf(parser->scanner, lit("#T: ~s isn't a function name"),
             name, nao);
  } else if (!memq(name, tree_fun_whitelist)) {
    yyerrorf(parser->scanner, lit("#T: ~s not in *tree-fun-whitelist*"),
             name, nao);
  } else {
    val fbinding = lookup_fun(nil, name);
    if (fbinding)
      return cdr(fbinding);
    yyerrorf(parser->scanner, lit("#T: function named ~s doesn't exist"),
             name, nao);
  }

  return nil;
}

#ifndef YYEOF
#define YYEOF 0
#endif

void yybadtoken(parser_t *parser, int tok, val context)
{
  val problem = nil;
  scanner_t *scnr = parser->scanner;

  switch (tok) {
  case ERRTOK:
    return;
  case SPACE:   problem = lit("space"); break;
  case TEXT:    problem = lit("text"); break;
  case SYMTOK:  problem = lit("symbol-token"); break;
  case METANUM: problem = lit("metanum"); break;
  case ALL:     problem = lit("\"all\""); break;
  case SOME:    problem = lit("\"some\""); break;
  case NONE:    problem = lit("\"none\""); break;
  case MAYBE:   problem = lit("\"maybe\""); break;
  case CASES:   problem = lit("\"cases\""); break;
  case BLOCK:   problem = lit("\"block\""); break;
  case CHOOSE:  problem = lit("\"choose\""); break;
  case GATHER:  problem = lit("\"gather\""); break;
  case AND:     problem = lit("\"and\""); break;
  case OR:      problem = lit("\"or\""); break;
  case END:     problem = lit("\"end\""); break;
  case COLLECT: problem = lit("\"collect\""); break;
  case UNTIL:   problem = lit("\"until\""); break;
  case COLL:    problem = lit("\"coll\""); break;
  case OUTPUT:  problem = lit("\"output\""); break;
  case REPEAT:  problem = lit("\"repeat\""); break;
  case REP:     problem = lit("\"rep\""); break;
  case SINGLE:  problem = lit("\"single\""); break;
  case FIRST:   problem = lit("\"first\""); break;
  case LAST:    problem = lit("\"last\""); break;
  case EMPTY:   problem = lit("\"empty\""); break;
  case MOD:     problem = lit("\"mod\""); break;
  case MODLAST: problem = lit("\"modlast\""); break;
  case DEFINE:  problem = lit("\"define\""); break;
  case TRY:     problem = lit("\"try\""); break;
  case CATCH:   problem = lit("\"catch\""); break;
  case FINALLY: problem = lit("\"finally\""); break;
  case IF:      problem = lit("\"if\""); break;
  case ELIF:    problem = lit("\"elif\""); break;
  case ELSE:    problem = lit("\"else\""); break;
  case NUMBER:  problem = lit("number"); break;
  case JSKW:    problem = lit("JSON keyword"); break;
  case REGCHAR: problem = lit("regular expression character"); break;
  case REGTOKEN: problem = lit("regular expression token"); break;
  case LITCHAR: problem = lit("string literal character"); break;
  case SPLICE:  problem = lit("*"); break;
  case JSPLICE: problem = lit("~*"); break;
  case CONSDOT:
  case LAMBDOT: problem = lit("consing dot"); break;
  case DOTDOT: problem = lit(".."); break;
  case OLD_DOTDOT:     problem = lit(".."); break;
  case UREFDOT:        problem = lit("referencing dot"); break;
  case OREFDOT:
  case UOREFDOT:       problem = lit("referencing .?"); break;
  case HASH_BACKSLASH: problem = lit("#\\"); break;
  case HASH_SLASH:     problem = lit("#/"); break;
  case HASH_H:         problem = lit("#H"); break;
  case HASH_S:         problem = lit("#S"); break;
  case HASH_R:         problem = lit("#R"); break;
  case HASH_N:         problem = lit("#N"); break;
  case HASH_T:         problem = lit("#T"); break;
  case HASH_J:         problem = lit("#J"); break;
  case HASH_SEMI:      problem = lit("#;"); break;
  case HASH_N_EQUALS:  problem = lit("#<n>="); break;
  case HASH_N_HASH:    problem = lit("#<n>#"); break;
  case HASH_B_QUOTE:   problem = lit("#b'"); break;
  case WORDS:   problem = lit("#\""); break;
  case WSPLICE: problem = lit("#*\""); break;
  case QWORDS:         problem = lit("#`"); break;
  case QWSPLICE:       problem = lit("#*`"); break;
  case OLD_AT:         problem = lit("@"); break;
  }

  if (problem != 0)
    if (context)
      yyerrorf(scnr, lit("misplaced ~a in ~a"), problem, context, nao);
    else
      yyerrorf(scnr, lit("unexpected ~a"), problem, nao);
  else
    if (context) /* Byacc sets yychar to 0 */
      if (tok == YYEOF || tok == YYEMPTY)
        yyerrorf(scnr, lit("unterminated ~a"), context, nao);
      else if (tok == '\n')
        yyerrorf(scnr, lit("newline in ~a"), context, nao);
      else
        yyerrorf(scnr, lit("misplaced character ~a in ~a"), chr(tok), context, nao);
    else
      if (tok == YYEOF)
        yyerrorf(scnr, lit("unexpected end of input"), nao);
      else if (tok == YYEMPTY)
        return;
      else
        yyerrorf(scnr, lit("unexpected character ~a"), chr(tok), nao);
}

int parse_once(val self, val stream, val name)
{
  int res = 0;
#if CONFIG_DEBUG_SUPPORT
  unsigned dbg_state = debug_clear(opt_dbg_expansion ? 0 : DBG_ENABLE);
#endif
  val parser_obj = ensure_parser(stream, name);
  parser_t *parser = parser_get_impl(self, parser_obj);
  parser->rec_source_loc = 1;

  uw_catch_begin(cons(error_s, nil), esym, eobj);


  res = yyparse(parser->scanner, parser);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind {
#if CONFIG_DEBUG_SUPPORT
    debug_set(dbg_state);
#endif
  }

  uw_catch_end;

  return res;
}

int parse(parser_t *parser, val name, enum prime_parser prim)
{
  int res = 0;
  cnum start_line = parser->lineno;

  parser->errors = 0;
  parser->eof = 0;
  parser->ignore = 0;
  parser->prepared_msg = nil;
  parser->circ_ref_hash = nil;
  parser->circ_count = 0;
  parser->syntax_tree = nil;
  parser->quasi_level = 0;

  prime_parser(parser, name, prim);

  uw_catch_begin(cons(error_s, nil), esym, eobj);

  res = yyparse(parser->scanner, parser);

  prime_parser_post(parser, prim);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind;

  uw_catch_end;

  if (parser->errors && parser->syntax_tree == nil &&
      parser->lineno != start_line)
  {
    cnum curline = parser->lineno;
    parser->lineno = start_line;
    yyerrorf(parser->scanner,
             lit("while parsing expression starting on this line"), nao);
    parser->lineno = curline;
  }

  return res;
}

